/* Type definitions used in the Maria expression evaluator -*- c++ -*- */

#ifndef TYPEDEFS_H_
# define TYPEDEFS_H_

# include <sys/types.h>
# include <climits>

/** @file typedefs.h
 * Type definitions used in the expression evaluator
 */

/** Signed integer type */
typedef signed int int_t;
/** Minimum value of int_t */
# define INT_T_MIN INT_MIN
/** Maximum value of int_t */
# define INT_T_MAX INT_MAX
/** Number of bits needed for representing int_t */
# define INT_T_BIT (CHAR_BIT * sizeof (int_t))
/** Unsigned integer (cardinality) type */
typedef unsigned int card_t;
/** Maximum value of card_t */
# define CARD_T_MAX UINT_MAX
/** Number of bits needed for representing card_t */
# define CARD_T_BIT (CHAR_BIT * sizeof (card_t))
/** Character type */
typedef unsigned char char_t;
/** Maximum value of char_t */
# define CHAR_T_MAX UCHAR_MAX
/** Number of bits needed for representing char_t */
# define CHAR_T_BIT (CHAR_BIT * sizeof (char_t))

#endif // TYPEDEFS_H_
