/* Error codes -*- c -*- */

#ifndef ERROR_H_
# define ERROR_H_

/** @file Error.h
 * Evaluation error codes from the compiled code
 */

/** Error codes */
enum Error {
  errNone = 0,	/* no error */
  errConst,	/* constraint violation */
  errVar,	/* undefined variable */
  errUndef,	/* undefined expression evaluated */
  errFatal,	/* fatal expression evaluated */
  errDiv0,	/* division by zero */
  errOver,	/* overflow */
  errMod,	/* modulus error */
  errShift,	/* shift error */
  errUnion,	/* attempt to reference a non-active union component */
  errBuf,	/* buffer boundary violation */
  /* codes not used by the low-level expression evaluator */
  errCard,	/* cardinality overflow */
  errComp	/* incompatible values (no actual error) */
};

#endif /* ERROR_H_ */
