/* A Bison parser, made from parser/maria.y
   by GNU bison 1.35.  */

#define YYBISON 1  /* Identify Bison output.  */

#define yyparse pnparse
#define yylex pnlex
#define yyerror pnerror
#define yylval pnlval
#define yychar pnchar
#define yydebug pndebug
#define yynerrs pnnerrs
# define	UNTIL	257
# define	RELEASE	258
# define	IMPL	259
# define	EQUIV	260
# define	OR	261
# define	XOR	262
# define	AND	263
# define	FINALLY	264
# define	GLOBALLY	265
# define	NEXT	266
# define	NE	267
# define	EQ	268
# define	GE	269
# define	LE	270
# define	ROL	271
# define	ROR	272
# define	IS	273
# define	CARDINALITY	274
# define	MIN	275
# define	MAX	276
# define	MAP	277
# define	EQUALS	278
# define	SUBSET	279
# define	MINUS	280
# define	UNION	281
# define	INTERSECT	282
# define	ATOM	283
# define	NUMBER	284
# define	CHARACTER	285
# define	NAME	286
# define	TRUE_	287
# define	FALSE_	288
# define	UNDEFINED	289
# define	FATAL	290
# define	TYPEDEF	291
# define	CONST	292
# define	PLACE	293
# define	TRANS	294
# define	IN	295
# define	OUT	296
# define	GATE	297
# define	REJECT_	298
# define	DEADLOCK	299
# define	ENUM	300
# define	ID	301
# define	STRUCT	302
# define	QUEUE	303
# define	STACK	304
# define	RANGE	305
# define	EMPTY	306
# define	SFAIR	307
# define	WFAIR	308
# define	ENABLED	309
# define	HIDE	310
# define	PROP	311

#line 3 "parser/maria.y"

#if !defined __WIN32 && !defined __CYGWIN__ && !defined __APPLE__
# include <alloca.h>
#endif // !__WIN32 && !__CYGWIN__ && !__APPLE__

#include "util.h"
#include "Printer.h"
#include "VariableStackMap.h"

#include "allExpressions.h"
#include "ExpressionSet.h"
#include "Constraint.h"
#include "Range.h"

#include "Arc.h"
#include "Transition.h"
#include "Place.h"
#include "Net.h"
#include "VariableDefinition.h"
#include "VariableSet.h"
#include "Function.h"

#include "Quantifier.h"

#include "TransitionQualifier.h"

#include "allTypes.h"
#include "allValues.h"
#include "Valuation.h"
#include "Substitution.h"

# include <set>
# include <map>
# include <list>
# include <stack>

# ifndef NDEBUG
#  define ASSERT1(x) x
# else
#  define ASSERT1(x)
# endif

  /** @file maria.y
   * Parser for the modelling language
   */

  /** warning flag (true=print warnings) */
  extern bool pnwarnings;
  /** number of errors encountered */
  extern unsigned pnerrors;
  /** Maximum index type size of arrays */
  card_t maxIndex = 256;
  /** Maximum range size of quantifications */
  card_t maxRange = 256;

  /** lexical analyzer function
   * @return		a terminal symbol, and set yylval to its semantic value
   */
  extern int pnlex ();

  /** Check the validity of an identifier
   * @param name	name of the identifier
   * @param type	type of the identifier
   * @param msg		error message
   */
  extern void checkName (const char* name, unsigned type, const char* msg);
  /** validity check codes for checkName */
  enum checkNameType {
    ckPlace = 0, ckTrans, ckType, ckEnum, ckComp,
    ckFunc, ckParam, ckVar, ckIter
  };

  /** The Petri Net */
  extern class Net* net;
# define theNet (*net)
  /** The printer object */
  extern class Printer thePrinter;
  /** Parameters of the function that is currently being processed */
  static class VariableDefinition** currentParameters = NULL;
  /** Arity of the function that is currently being processed */
  static unsigned currentArity = 0;
  /** Function being invoked */
  static std::stack< class Function*, std::list<class Function*> >
    functionStack;
  /** The place that is currently being processed */
  class Place* currentPlace = NULL;
  /** The transition that is currently being processed */
  class Transition* currentTransition = NULL;
  /** The context transition (not being processed) */
  static class Transition* currentContextTransition = NULL;
  /** The type definition that is currently being processed */
  static const class Type* currentType = NULL;
  /** The context type of currentType (StructType or VectorType or NULL) */
  static const class Type* currentContextType = NULL;
  /** Struct or vector component number currently being parsed */
  static card_t currentComponent;
  /** Type context */
  struct TypeContext
  {
    /** Context type (@see currentContextType), may be NULL */
    const class Type* context;
    /** Component type (@see currentContext) */
    const class Type* component;
    /** Number of current component (@see currentComponent)
     * , meaningless if context==NULL */
    card_t numComponent;
  };
  /** Stack of types, used e.g. when parsing quantifier conditions */
  static std::stack< struct TypeContext, std::list<struct TypeContext> >
    typeStack;
  /** Flag: is an output arc being parsed? */
  static bool isOutputArc = false;
  /** Flag: has a number been successfully parsed? */
  static bool numberParsed = false;

  /** Flag: has an empty list component been parsed? */
  static bool emptyParsed = false;

  /** type of constraint being parsed */
  static enum Net::CKind isFairnessStrong;

  typedef std::pair<const class Type*,card_t> StructLevel;
  /** Stack for parsing structs and vectors */
  static std::stack< StructLevel, std::list<StructLevel> > structLevels;

  /** check the validity of an iterator variable name
   * @param name	name of the identifier variable
   */
  static void checkIterator (const char* name);

  /** Make a copy of a type if it is not an unnamed user type
   * @param type	the type to be copied
   * @return		type or a copy of it
   */
  static class Type* copyType (class Type* type);

  /** Delete the type definition if it is an unnamed user type
   * @param type	the type to be deleted
   */
  static void deleteType (class Type* type);

  /** Display a type name in an error message
   * @param type	type to be displayed
   */
  static void printType (const class Type& type);

  /** Push the type context on structLevels
   * @param type	new type context
   */
  static void pushTypeContext (const class Type* type);
  /** Restore the type context from structLevels */
  static void popTypeContext ();

  /** Get the parameter of the currently parsed function by name
   * @param name	name of the parameter
   * @return		the corresponding VariableDefinition, or NULL
   */
  static const class VariableDefinition* getParameter (char* name);

  /** Add a parameter to the function definition being parsed
   * @param type	type of the parameter
   * @param name	name of the parameter
   */
  static void addParameter (const class Type* type, char* name);

  /** Get a Function by name
   * @param name	the function name
   * @return		a Function object
   */
  static class Function* getFunction (const char* name);

  /** Get a zero-arity Function by name
   * @param name	the function name
   * @return		a Function object
   */
  static class Function* getConstantFunction (const char* name);
  
  /** Get a Constant by name
   * @param name	the constant name
   * @return		a Constant object
   */
  static const class Constant* getConstant (const char* name);

  /** Get a VariableDefinition by name
   * @param name	the variable name
   * @return		a VariableDefinition object
   */
  static const class VariableDefinition* getVariable (char* name);

  /** Resolve a name to a constant or variable
   * @param name	the name
   * @return		the resolved expression, or NULL
   */
  static class Expression* resolveName (char* name);

  /** Ensure that the formula is a set-valued expression
   * @param expr	formula to be checked
   * @param type	expected type of the formula
   * @return		expr, pointer to a Marking object, or NULL
   */
  static class Expression* ensureSet (class Expression* expr,
				      const class Type* type = 0);

  /** Ensure that the formula is a marking expression, converting if needed
   * @param expr	formula to be checked
   * @param type	expected type of the expression
   * @param temporal	flag: allow expr to be temporal
   * @return		pointer to a Marking object, or NULL
   */
  static class Marking* ensureMarking (class Expression* expr,
				       const class Type* type,
				       bool temporal = false);

  /** Ensure that the formula is not a marking expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* noMarking (class Expression* expr);

  /** Ensure that the formula is a basic expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureExpr (class Expression* expr);

  /** Ensure that the formula is a boolean expression
   * @param expr	formula to be checked
   * @param undefined	flag: allow the formula to be Undefined
   * @return		expr or NULL
   */
  static class Expression* ensureBool (class Expression* expr,
				       bool undefined = false);

  /** Ensure that the formula is a signed integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureInt (class Expression* expr);

  /** Ensure that the formula is an unsigned integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureCard (class Expression* expr);

  /** Ensure that the formula is a signed or unsigned integer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureIntCard (class Expression* expr);

  /** Ensure that the formula is a buffer expression
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureBuffer (class Expression* expr);

  /** Ensure that the formula is a basic expression of ordered type
   * @param expr	formula to be checked
   * @return		expr or NULL
   */
  static class Expression* ensureOrdered (class Expression* expr);

  /** Add an enumeration constant to an enumerated type, ensuring uniqueness.
   * @param e		the enumeration type
   * @param name	name of the constant
   */
  static void addEnumeration (class EnumType* e, char* name);

  /** Add an enumeration constant to an enumerated type, ensuring uniqueness.
   * @param e		the enumeration type
   * @param name	name of the constant
   * @param value	value of the constant
   */
  static void addEnumeration (class EnumType* e, char* name, card_t value);

  /** Ensure that the formula is a constant literal
   * @param expr	formula to be checked
   * @param type	type of the constant expected
   * @return		the value of expr or NULL
   */
  static class Value* ensureConstant (class Expression* expr,
				      const class Type* type);

  /** Convert an integer to an enumeration value if possible
   * @param type	type of the enumeration value
   * @param value	numerical value to be converted to the enumeration type
   * @return		a constant having the enumeration value or NULL
   */
  static class Expression* enumValue (const class EnumType& type,
				      card_t value);

  /** Ensure that a named component matches a struct being parsed
   * @param name	name of the component
   * @param expr	initialization expression for the component
   * @return		expr or NULL
   */
  static class Expression* namedComponent (char* name, class Expression* expr);

  /** Begin parsing a non-determinism expression
   * @param type	type of the expression
   * @param hidden	flag: hide the variable from transition instances
   * @param name	name of the non-deterministic variable (optional)
   */
  static void beginAny (class Type*& type, char* name, bool hidden);

  /** End parsing a non-determinisim expression
   * @param type	type of the expression
   * @param name	name of the non-deterministic variable (optional)
   * @param condition	quantification condition (optional)
   * @return		a Variable expression for the variable, or NULL
   */
  static class Variable* endAny (const class Type* type, char* name,
				 class Expression* condition);

  /** Begin parsing a quantifier expression
   * @param name	name of the quantifier variable
   * @param type	type of the quantifier variable
   */
  static void beginQuantifier (char* name, const class Type* type);

  /** Continue parsing a quantifier expression
   *  (after parsing an optional condition)
   * @param type	type of the quantifier variable
   */
  static void continueQuantifier (ASSERT1 (const class Type* type));

  /** End parsing a quantifier expression
   * @param name	name of the quantifier variable
   * @param type	type of the quantifier variable
   * @param condition	quantification condition (optional)
   * @param kind	quantification kind (1=sum, 2=forall, 3=exists)
   * @param expr	expression
   * @param temporal	flag: allow expr to be temporal
   * @return		expr augmented with the quantifier, or NULL if failed
   */
  static class Expression* endQuantifier (char* name, const class Type* type,
					  class Expression* condition,
					  unsigned kind,
					  class Expression* expr,
					  bool temporal);

  /** Declare a quantified variable
   * @param prefix	prefix of the quantified variable
   * @param quant	name of the quantifier variable
   * @param p		flag: use a predecessor value of the quantifier
   * @return		a quantified variable, or NULL if failed
   */
  static class Expression* quantifierVariable (char* prefix,
					       char* quant,
					       bool p);

  /** Try to make expr compatible with type if expr is a Constant
   * @param expr	expression to be made compatible
   * @param type	type to be made compatible with
   * @param casting	flag: typecasting in progress (suppress a warning)
   * @return		true if expr is not a Constant or
   *			if the conversion succeeded
   */
  static bool makeCompatible (class Expression*& expr,
			      const class Type& type,
			      bool casting = false);

  /** Determine whether an expression is compatible with a type
   * @param expr	expression to be checked
   * @param type	the type
   * @return		true if the expression is compatible with the type
   */
  static bool isCompatible (class Expression*& expr,
			    const class Type* type);

  /** Determine whether an expression is compatible with
   * the struct component being parsed
   * @param expr	expression to be checked
   * @param s		the struct whose current component is considered
   * @return		true if the expression is compatible with the struct
   */
  static bool isCompatible (class Expression*& expr,
			    const class StructExpression& s);

  /** Ensure that the type is ordered
   * @param type	type to be checked
   * @return		true if the type is ordered
   */
  static bool isOrdered (const class Type& type);

  /** Check a valuation
   * @param v		valuation to be checked
   * @return		true if the valuation is OK
   */
  static bool check (const class Valuation& v);

  /** Perform constant folding
   * @param expr	expression to be folded
   * @return		expr or a new Constant, or NULL in case of error
   */
  static class Expression* fold (class Expression* expr);

  /** Define a function
   * @param type	type of the function
   * @param name	name of the function
   * @param expr	body of the function
   */
  static void defun (const class Type* type,
		     char* name,
		     class Expression* expr);

  /** Create a RelopExpression or optimize it
   * @param equal	flag: equality comparison (instead of less-than)
   * @param left	left-hand-side of RelopExpression
   * @param right	right-hand-side of RelopExpression
   * @return		RelopExpression or a Boolean constant
   */
  static class Expression* newRelopExpression (bool equal,
					       class Expression* left,
					       class Expression* right);

  /** Create a BinopExpression
   * @param op		operator
   * @param left	left-hand-side of BinopExpression
   * @param right	right-hand-side of BinopExpression
   * @return		BinopExpression
   */
  static class Expression* newBinopExpression (enum BinopExpression::Op op,
					       class Expression* left,
					       class Expression* right);

  /** Create a NotExpression or optimize it
   * @param expr	an expression
   * @return		a negation of the expression
   */
  static class Expression* newNotExpression (class Expression* expr);

  /** Create a BooleanBinop or optimize it
   * @param conj	flag: conjunction (instead of disjunction)
   * @param left	left-hand-side of BooleanBinop
   * @param right	right-hand-side of BooleanBinop
   * @return		left, right, Boolean constant, or a BooleanBinop
   */
  static class Expression* newBooleanBinop (bool conj,
					    class Expression* left,
					    class Expression* right);

  /** Create a SetExpression or optimize it
   * @param op		operator
   * @param left	left-hand-side of SetExpression
   * @param right	right-hand-side of SetExpression
   */
  static class Expression* newSetExpression (enum SetExpression::Op op,
					     class Expression* left,
					     class Expression* right);
  /** Create a CardinalityExpression or optimize it
   * @param op		operator
   * @param expr	the multi-set expression
   */
  static class Expression* newCardinalityExpression
    (enum CardinalityExpression::Op op,
     class Expression* expr);

  /** Create a BufferUnop from a buffer expression
   * @param op		operator
   * @param expr	the buffer expression
   * @return		a BufferUnop object, or NULL
   */
  static class Expression* newBufferUnop (enum BufferUnop::Op op,
					  class Expression* expr);

  /** Variable stack map to be used with variable scoping */
  static class VariableStackMap currentVariables;

  /**
   * generic compiler warning reporting function
   * @param s		warning message
   */
  extern void pnwarn (const char* s);

  /**
   * generic parser error reporting function
   * @param s		error message
   */
  extern void pnerror (const char* s);

#line 486 "parser/maria.y"
#ifndef YYSTYPE
typedef union{
  card_t i;
  bool flag;
  char_t c;
  char* s;
  class Expression* expr;
  class ExpressionList* exprList;
  class Transition* trans;
  class Place* place;
  class Marking* marking;
  class Type* type;
  class ComponentList* componentList;
  class Value* value;
  class Range* range;
  class Constraint* constraint;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
#ifndef YYDEBUG
# define YYDEBUG 0
#endif



#define	YYFINAL		457
#define	YYFLAG		-32768
#define	YYNTBASE	83

/* YYTRANSLATE(YYLEX) -- Bison token number corresponding to YYLEX. */
#define YYTRANSLATE(x) ((unsigned)(x) <= 311 ? yytranslate[x] : 185)

/* YYTRANSLATE[YYLEX] -- Bison token number corresponding to YYLEX. */
static const char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    34,     2,    31,     2,    30,    17,     2,
      47,    80,    28,    26,    82,    27,    45,    29,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     4,    76,
      22,    81,    23,     3,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    46,     2,    79,    16,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    77,    15,    78,    33,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    18,    19,    20,
      21,    24,    25,    32,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75
};

#if YYDEBUG
static const short yyprhs[] =
{
       0,     0,     1,     3,     5,     8,    11,    15,    17,    19,
      21,    23,    25,    27,    29,    33,    35,    37,    40,    43,
      48,    53,    58,    63,    65,    66,    70,    75,    81,    86,
      90,    94,    96,    98,   101,   105,   108,   110,   112,   114,
     116,   118,   120,   121,   123,   124,   126,   128,   129,   131,
     132,   134,   138,   142,   148,   150,   152,   154,   157,   162,
     165,   166,   168,   170,   172,   173,   179,   180,   188,   191,
     196,   199,   200,   201,   202,   206,   207,   210,   211,   219,
     221,   222,   226,   227,   230,   231,   234,   235,   242,   245,
     246,   251,   252,   257,   258,   263,   264,   269,   270,   275,
     276,   281,   286,   289,   290,   292,   296,   299,   303,   304,
     311,   314,   315,   318,   322,   324,   328,   329,   332,   333,
     339,   340,   343,   346,   348,   351,   354,   355,   358,   361,
     363,   366,   369,   371,   375,   377,   380,   383,   388,   389,
     393,   395,   397,   399,   402,   405,   408,   410,   414,   416,
     418,   420,   424,   426,   427,   432,   433,   437,   438,   440,
     443,   447,   449,   453,   454,   456,   458,   460,   462,   464,
     466,   468,   471,   472,   478,   480,   482,   485,   487,   489,
     491,   493,   495,   496,   501,   502,   507,   508,   513,   517,
     520,   521,   526,   527,   533,   537,   541,   545,   549,   553,
     557,   561,   565,   569,   573,   577,   580,   583,   586,   589,
     592,   595,   598,   601,   604,   607,   611,   615,   619,   623,
     627,   631,   632,   633,   644,   645,   653,   657,   658,   664,
     667,   671,   675,   679,   683,   687,   690,   693,   696,   700,
     704,   706,   710,   714,   718,   722,   726,   729,   732,   735,
     739,   743,   744,   745,   753,   757,   761,   762,   770,   771,
     779,   780,   790,   791,   792,   795,   796,   801,   804,   806,
     810,   811,   812,   820,   821,   826,   828,   832,   835,   839,
     843,   847,   851
};
static const short yyrhs[] =
{
      -1,    84,     0,    76,     0,    84,    76,     0,    85,    76,
       0,    84,    85,    76,     0,    86,     0,   108,     0,   115,
       0,   121,     0,   146,     0,   144,     0,   145,     0,    55,
      88,    99,     0,    67,     0,    68,     0,    87,    67,     0,
      87,    68,     0,    64,    77,   102,    78,     0,    65,    46,
      96,    79,     0,    66,    77,   105,    78,     0,    42,    77,
     105,    78,     0,    95,     0,     0,    88,    89,    90,     0,
      88,    46,    88,    79,     0,    88,    46,    87,    96,    79,
       0,    88,    46,    48,    79,     0,    47,    91,    80,     0,
      91,   103,    92,     0,    92,     0,    94,     0,    69,    94,
       0,    93,    69,    93,     0,    93,    69,     0,   159,     0,
     158,     0,    97,     0,   159,     0,    50,     0,     1,     0,
       0,    97,     0,     0,    97,     0,    97,     0,     0,    81,
       0,     0,   100,     0,   102,   103,   100,     0,   100,   101,
      96,     0,   102,   103,   100,   101,    96,     0,    76,     0,
      82,     0,    99,     0,    88,   104,     0,   105,   103,    88,
     104,     0,   105,   103,     0,     0,    14,     0,    81,     0,
      99,     0,     0,    95,   107,   106,   109,   161,     0,     0,
      95,   107,    47,   111,    80,   110,   161,     0,    95,    99,
       0,   111,   103,    95,    99,     0,   111,   103,     0,     0,
       0,     0,   112,   113,    90,     0,     0,   114,    56,     0,
       0,   139,    97,   112,    88,   114,   116,   118,     0,    99,
       0,     0,   118,     4,   152,     0,     0,   119,     4,     0,
       0,   120,    34,     0,     0,   141,   119,    97,   120,   122,
     124,     0,   141,    99,     0,     0,   124,    77,   130,    78,
       0,     0,   124,    59,   125,   134,     0,     0,   124,    60,
     126,   134,     0,     0,   124,    61,   127,   142,     0,     0,
     124,   148,   128,   161,     0,     0,   124,    74,   129,   159,
       0,   124,     4,   140,    99,     0,   124,    48,     0,     0,
     131,     0,   130,   103,   131,     0,   130,   103,     0,   133,
      95,    99,     0,     0,   133,    95,    97,    34,   132,   155,
       0,   133,   108,     0,     0,   133,    74,     0,    77,   135,
      78,     0,   136,     0,   135,    76,   136,     0,     0,   138,
       1,     0,     0,   138,   117,     4,   137,   152,     0,     0,
     138,    57,     0,   138,    58,     0,    57,     0,   139,    57,
       0,   139,    58,     0,     0,   138,    58,     0,   138,    57,
       0,    58,     0,   141,    58,     0,   141,    57,     0,   143,
       0,   142,    82,   143,     0,   159,     0,    62,   159,     0,
      63,   159,     0,    75,    99,     4,   159,     0,     0,   148,
     147,   149,     0,    72,     0,    71,     0,    73,     0,   148,
      72,     0,   148,    71,     0,   148,    73,     0,   150,     0,
     149,    82,   150,     0,   181,     0,   161,     0,   151,     0,
     152,    82,   151,     0,   161,     0,     0,   153,    82,   154,
     151,     0,     0,    47,   158,    80,     0,     0,   159,     0,
      50,     4,     0,    50,     4,   159,     0,   156,     0,   157,
      82,   156,     0,     0,   159,     0,   161,     0,     1,     0,
       4,     0,     9,     0,    11,     0,     1,     0,    97,    14,
       0,     0,    97,    47,   162,   177,    80,     0,    51,     0,
      52,     0,   139,   117,     0,    50,     0,    48,     0,    49,
       0,    53,     0,    54,     0,     0,    77,   163,   157,    78,
       0,     0,    32,    95,   164,   161,     0,     0,    97,    81,
     165,   161,     0,   161,    32,    99,     0,    44,   161,     0,
       0,    95,    34,   166,   155,     0,     0,    95,    97,    34,
     167,   155,     0,   161,    22,   161,     0,   161,    19,   161,
       0,   161,    23,   161,     0,   161,    20,   161,     0,   161,
      18,   161,     0,   161,    21,   161,     0,   161,    26,   161,
       0,   161,    27,   161,     0,   161,    29,   161,     0,   161,
      28,   161,     0,   161,    30,   161,     0,    33,   161,     0,
      31,    95,     0,    22,    95,     0,    23,    95,     0,    15,
     161,     0,    26,   161,     0,    27,   161,     0,    28,   161,
       0,    29,   161,     0,    30,   161,     0,   161,    24,   161,
       0,   161,    25,   161,     0,   161,    17,   161,     0,   161,
      16,   161,     0,   161,    15,   161,     0,   161,     3,   180,
       0,     0,     0,   161,    45,    77,    46,   168,   158,    79,
     169,   158,    78,     0,     0,   161,    45,    77,    97,   170,
     158,    78,     0,   161,    45,    97,     0,     0,   161,    46,
     171,   159,    79,     0,    34,   161,     0,   161,    11,   161,
       0,   161,     9,   161,     0,   161,     7,   161,     0,   161,
      10,   161,     0,   161,     8,   161,     0,    12,   161,     0,
      13,   161,     0,    14,   161,     0,   161,     5,   161,     0,
     161,     6,   161,     0,    70,     0,   161,    40,   161,     0,
     161,    43,   161,     0,   161,    41,   161,     0,   161,    42,
     161,     0,   161,    39,   161,     0,    35,   161,     0,    36,
     161,     0,    37,   161,     0,    47,   153,    80,     0,   161,
      31,   161,     0,     0,     0,    95,    97,   172,   155,   173,
     160,   161,     0,    45,    97,    98,     0,     4,    97,    98,
       0,     0,    40,    99,    77,   153,    78,   174,   161,     0,
       0,    38,    99,    77,   153,    78,   175,   161,     0,     0,
      38,    99,    31,    99,    77,   153,    78,   176,   161,     0,
       0,     0,   178,   161,     0,     0,   177,    82,   179,   161,
       0,   177,    82,     0,   161,     0,   180,     4,   161,     0,
       0,     0,    95,    97,   182,   155,   183,   160,   181,     0,
       0,   123,     4,   184,   161,     0,   123,     0,    47,   181,
      80,     0,    34,   181,     0,   181,    11,   181,     0,   181,
       9,   181,     0,   181,     7,   181,     0,   181,    10,   181,
       0,   181,     8,   181,     0
};

#endif

#if YYDEBUG
/* YYRLINE[YYN] -- source line where rule number YYN was defined. */
static const short yyrline[] =
{
       0,   611,   612,   616,   618,   621,   623,   627,   629,   631,
     633,   635,   637,   639,   643,   663,   666,   669,   672,   677,
     683,   694,   697,   709,   712,   712,   734,   760,   776,   784,
     789,   797,   802,   805,   808,   820,   825,   830,   835,   858,
     912,   915,   920,   922,   927,   929,   934,   942,   943,   947,
     949,   959,   969,   980,   995,   995,   997,  1005,  1020,  1049,
    1057,  1061,  1063,  1067,  1075,  1075,  1080,  1080,  1092,  1100,
    1108,  1115,  1119,  1121,  1121,  1142,  1144,  1149,  1149,  1184,
    1201,  1203,  1215,  1217,  1222,  1224,  1229,  1229,  1302,  1320,
    1321,  1323,  1323,  1327,  1327,  1331,  1331,  1336,  1336,  1353,
    1353,  1364,  1381,  1393,  1395,  1398,  1405,  1414,  1447,  1447,
    1452,  1457,  1459,  1464,  1468,  1470,  1474,  1475,  1478,  1478,
    1510,  1512,  1515,  1520,  1522,  1525,  1530,  1532,  1535,  1540,
    1542,  1545,  1550,  1552,  1556,  1588,  1591,  1596,  1615,  1615,
    1621,  1624,  1627,  1630,  1633,  1636,  1641,  1643,  1647,  1655,
    1660,  1663,  1673,  1676,  1676,  1689,  1691,  1696,  1698,  1701,
    1704,  1709,  1774,  1864,  1866,  1871,  1876,  1879,  1882,  1885,
    1890,  1893,  1914,  1914,  1944,  1950,  1956,  1959,  1962,  1968,
    1974,  1977,  1980,  1980,  2112,  2112,  2129,  2129,  2191,  2226,
    2229,  2229,  2234,  2234,  2239,  2242,  2245,  2248,  2251,  2254,
    2257,  2281,  2300,  2303,  2306,  2309,  2315,  2332,  2340,  2348,
    2354,  2360,  2379,  2382,  2385,  2388,  2391,  2394,  2397,  2400,
    2403,  2433,  2433,  2433,  2470,  2470,  2513,  2562,  2562,  2617,
    2620,  2630,  2640,  2650,  2656,  2659,  2667,  2675,  2683,  2694,
    2705,  2708,  2711,  2714,  2717,  2720,  2723,  2726,  2729,  2732,
    2735,  2790,  2790,  2790,  2797,  2800,  2803,  2803,  2853,  2853,
    2890,  2890,  2944,  2963,  2963,  2996,  2996,  3034,  3040,  3048,
    3071,  3071,  3071,  3078,  3078,  3090,  3100,  3103,  3106,  3115,
    3124,  3133,  3136
};
#endif


#if (YYDEBUG) || defined YYERROR_VERBOSE

/* YYTNAME[TOKEN_NUM] -- String name of the token TOKEN_NUM. */
static const char *const yytname[] =
{
  "$", "error", "$undefined.", "'?'", "':'", "UNTIL", "RELEASE", "IMPL", 
  "EQUIV", "OR", "XOR", "AND", "FINALLY", "GLOBALLY", "NEXT", "'|'", 
  "'^'", "'&'", "NE", "EQ", "GE", "LE", "'<'", "'>'", "ROL", "ROR", "'+'", 
  "'-'", "'*'", "'/'", "'%'", "'#'", "IS", "'~'", "'!'", "CARDINALITY", 
  "MIN", "MAX", "MAP", "EQUALS", "SUBSET", "MINUS", "UNION", "INTERSECT", 
  "ATOM", "'.'", "'['", "'('", "NUMBER", "CHARACTER", "NAME", "TRUE_", 
  "FALSE_", "UNDEFINED", "FATAL", "TYPEDEF", "CONST", "PLACE", "TRANS", 
  "IN", "OUT", "GATE", "REJECT_", "DEADLOCK", "ENUM", "ID", "STRUCT", 
  "QUEUE", "STACK", "RANGE", "EMPTY", "SFAIR", "WFAIR", "ENABLED", "HIDE", 
  "PROP", "';'", "'{'", "'}'", "']'", "')'", "'='", "','", "start", "net", 
  "netcomponent", "type", "queue_stack", "typedefinition", "@1", 
  "constraint", "range_list", "range", "value", "value_", "typereference", 
  "number", "name_", "_opt_name", "name", "enum_name", "_opt_eq", 
  "enum_list", "delim", "comp_name", "comp_list", "next_eq", "func_name", 
  "function", "@2", "@3", "param_list", "_opt_capacity", "@4", 
  "_opt_const", "place", "@5", "placename", "place_init", "_opt_colon", 
  "_opt_exclam", "transition", "@6", "transname", "trans", "@7", "@8", 
  "@9", "@10", "@11", "_list_var_expr", "var_expr", "@12", "_opt_hide", 
  "trans_places", "_list_place_marking", "place_marking", "@13", 
  "_opt_place", "_nopt_place", "_opt_trans", "_nopt_trans", "gate_list", 
  "gate", "verify", "prop", "fairness", "@14", "fairness_strong", "fair", 
  "fair_expr", "marking", "marking_list", "marking_list_", "@15", 
  "_opt_expr", "_opt__expr", "struct_expr", "expr_", "expr", "quantifier", 
  "formula", "@16", "@17", "@18", "@19", "@20", "@21", "@22", "@23", 
  "@24", "@25", "@26", "@27", "@28", "@29", "@30", "arg_list", "@31", 
  "@32", "colon_formula", "qual_expr", "@33", "@34", "@35", 0
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives. */
static const short yyr1[] =
{
       0,    83,    83,    84,    84,    84,    84,    85,    85,    85,
      85,    85,    85,    85,    86,    87,    87,    87,    87,    88,
      88,    88,    88,    88,    89,    88,    88,    88,    88,    90,
      91,    91,    92,    92,    92,    92,    93,    94,    95,    96,
      97,    97,    98,    98,    99,    99,   100,   101,   101,   102,
     102,   102,   102,   102,   103,   103,   104,   105,   105,   105,
     105,   106,   106,   107,   109,   108,   110,   108,   111,   111,
     111,   111,   112,   113,   112,   114,   114,   116,   115,   117,
     118,   118,   119,   119,   120,   120,   122,   121,   123,   124,
     124,   125,   124,   126,   124,   127,   124,   128,   124,   129,
     124,   124,   124,   130,   130,   130,   130,   131,   132,   131,
     131,   133,   133,   134,   135,   135,   136,   136,   137,   136,
     138,   138,   138,   139,   139,   139,   140,   140,   140,   141,
     141,   141,   142,   142,   143,   144,   144,   145,   147,   146,
     148,   148,   148,   148,   148,   148,   149,   149,   150,   151,
     152,   152,   153,   154,   153,   155,   155,   156,   156,   156,
     156,   157,   157,   158,   158,   159,   160,   160,   160,   160,
     161,   161,   162,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   163,   161,   164,   161,   165,   161,   161,   161,
     166,   161,   167,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   168,   169,   161,   170,   161,   161,   171,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   161,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   172,   173,   161,   161,   161,   174,   161,   175,   161,
     176,   161,   177,   178,   177,   179,   177,   177,   180,   180,
     182,   183,   181,   184,   181,   181,   181,   181,   181,   181,
     181,   181,   181
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN. */
static const short yyr2[] =
{
       0,     0,     1,     1,     2,     2,     3,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     1,     2,     2,     4,
       4,     4,     4,     1,     0,     3,     4,     5,     4,     3,
       3,     1,     1,     2,     3,     2,     1,     1,     1,     1,
       1,     1,     0,     1,     0,     1,     1,     0,     1,     0,
       1,     3,     3,     5,     1,     1,     1,     2,     4,     2,
       0,     1,     1,     1,     0,     5,     0,     7,     2,     4,
       2,     0,     0,     0,     3,     0,     2,     0,     7,     1,
       0,     3,     0,     2,     0,     2,     0,     6,     2,     0,
       4,     0,     4,     0,     4,     0,     4,     0,     4,     0,
       4,     4,     2,     0,     1,     3,     2,     3,     0,     6,
       2,     0,     2,     3,     1,     3,     0,     2,     0,     5,
       0,     2,     2,     1,     2,     2,     0,     2,     2,     1,
       2,     2,     1,     3,     1,     2,     2,     4,     0,     3,
       1,     1,     1,     2,     2,     2,     1,     3,     1,     1,
       1,     3,     1,     0,     4,     0,     3,     0,     1,     2,
       3,     1,     3,     0,     1,     1,     1,     1,     1,     1,
       1,     2,     0,     5,     1,     1,     2,     1,     1,     1,
       1,     1,     0,     4,     0,     4,     0,     4,     3,     2,
       0,     4,     0,     5,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     3,     3,     3,     3,     3,
       3,     0,     0,    10,     0,     7,     3,     0,     5,     2,
       3,     3,     3,     3,     3,     2,     2,     2,     3,     3,
       1,     3,     3,     3,     3,     3,     2,     2,     2,     3,
       3,     0,     0,     7,     3,     3,     0,     7,     0,     7,
       0,     9,     0,     0,     2,     0,     4,     2,     1,     3,
       0,     0,     7,     0,     4,     1,     3,     2,     3,     3,
       3,     3,     3
};

/* YYDEFACT[S] -- default rule to reduce with in state S when YYTABLE
   doesn't specify something else to do.  Zero means the default is an
   error. */
static const short yydefact[] =
{
       0,    41,    40,     0,   123,   129,     0,     0,   141,   140,
     142,     0,     3,     0,     0,     7,     0,    38,     8,     9,
      10,     0,    82,    12,    13,    11,   138,     0,     0,     0,
       0,     0,    23,   170,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   178,   179,
     177,   174,   175,   180,   181,   240,   182,     0,    38,     0,
     135,   165,   136,    45,     0,     4,     0,     5,    63,     0,
     124,   125,    72,   131,   130,     0,   144,   143,   145,     0,
       0,     0,     0,     0,     0,     0,    14,     0,   235,   236,
     237,   209,   207,   208,   210,   211,   212,   213,   214,   206,
     184,   205,   229,   246,   247,   248,     0,     0,   189,     0,
       0,   152,     0,   190,   251,   171,   172,   186,    79,   176,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   227,     0,     6,    61,     0,    62,    64,     0,
      83,    84,     0,     0,     0,   275,     0,   139,   146,   148,
       0,     0,    46,    47,     0,     0,    39,     0,     0,    15,
      16,     0,    24,     0,    25,    43,   255,     0,     0,     0,
       0,   254,   249,   153,   177,   161,     0,   158,   155,   192,
     155,   263,     0,   268,   220,   238,   239,   232,   234,   231,
     233,   230,   219,   218,   217,   198,   195,   197,   199,   194,
     196,   215,   216,   200,   201,   203,   202,   204,   250,   188,
     245,   241,   243,   244,   242,     0,   226,     0,   137,     0,
       0,     0,    75,     0,    86,   277,     0,   270,   273,    88,
       0,     0,     0,     0,     0,     0,    56,    57,    54,    22,
      55,     0,    48,     0,    19,     0,    20,    21,    28,    17,
      18,     0,    26,     0,     0,    31,     0,    32,    37,   164,
     185,     0,     0,     0,     0,     0,   183,     0,     0,   191,
     155,   252,     0,     0,   187,     0,   221,   224,     0,    68,
      66,     0,    65,    77,    74,    85,    89,   276,   155,     0,
     147,   280,   282,   279,   281,   278,     0,    52,    47,    27,
      33,   164,    29,     0,     0,     0,   258,   256,   154,   149,
     160,   162,     0,   193,     0,   173,   265,   264,   269,     0,
       0,   228,     0,     0,    76,    80,    87,   271,   274,    58,
       0,    30,    34,    36,     0,     0,     0,   156,   166,   167,
     168,   169,     0,     0,     0,     0,    67,    69,    78,   126,
     102,    91,    93,    95,    99,   103,    97,     0,    53,   260,
     259,   257,   253,   266,   222,   225,     0,     0,     0,     0,
       0,     0,     0,     0,   104,     0,     0,     0,     0,     0,
     150,    81,   128,   127,   101,   120,    92,    94,    96,   132,
     134,   100,    90,   106,   112,     0,   110,    98,   272,   261,
       0,     0,     0,   114,     0,     0,   105,    45,    63,   223,
     151,   120,   113,   117,   121,   122,     0,   133,   108,   115,
     118,   155,     0,   109,   119,     0,     0,     0
};

static const short yydefgoto[] =
{
     455,    13,    14,    15,   191,   180,    95,   194,   284,   285,
     286,   287,    67,   185,    68,   196,   128,   183,   273,   184,
     271,   267,   181,   168,    79,    18,   251,   352,   250,   169,
     253,   313,    19,   355,   129,   378,    85,   254,    20,   316,
     175,   356,   399,   400,   401,   406,   402,   403,   404,   451,
     405,   416,   432,   433,   452,   434,    69,   398,   176,   418,
     419,    23,    24,    25,    89,    26,   177,   178,   410,   411,
     120,   294,   299,   205,   206,   288,   331,   372,    71,   211,
     122,   197,   212,   208,   300,   349,   409,   350,   247,   210,
     344,   366,   365,   408,   302,   303,   373,   214,   179,   318,
     387,   319
};

static const short yypact[] =
{
     337,-32768,-32768,   492,-32768,-32768,  1570,  1570,-32768,-32768,
  -32768,    22,-32768,   439,   -61,-32768,    28,-32768,-32768,-32768,
  -32768,   374,     8,-32768,-32768,-32768,    74,   -53,   -50,   -11,
     -33,   233,-32768,   252,    27,  1570,  1570,  1570,  1570,    27,
      27,  1570,  1570,  1570,  1570,  1570,    27,    27,  1570,  1570,
    1570,  1570,  1570,     7,   162,  1570,    27,  1570,-32768,-32768,
     253,-32768,-32768,-32768,-32768,-32768,-32768,    36,   204,   759,
  -32768,   577,-32768,-32768,    84,-32768,    44,-32768,-32768,   212,
  -32768,-32768,-32768,-32768,-32768,   167,-32768,-32768,-32768,   502,
      61,   114,  1570,    61,   379,    59,-32768,   839,  1736,  1736,
    1736,   691,-32768,-32768,   691,   691,   691,   691,   691,-32768,
  -32768,   691,   691,   691,   691,   691,   -17,    47,   158,   839,
      95,   577,  1212,-32768,    98,-32768,-32768,-32768,-32768,-32768,
    1570,  1570,  1570,  1570,  1570,  1570,  1570,  1570,  1570,  1570,
    1570,  1570,  1570,  1570,  1570,  1570,  1570,  1570,  1570,  1570,
    1570,  1570,  1570,  1570,  1570,   919,  1570,  1570,  1570,  1570,
    1570,   178,-32768,  1570,-32768,-32768,   134,-32768,-32768,   440,
  -32768,-32768,   502,   502,    27,   145,    72,    78,-32768,   603,
     155,   147,-32768,   232,   301,    86,-32768,   308,    99,-32768,
  -32768,  1511,   -21,   999,-32768,-32768,-32768,  1570,   162,  1570,
    1570,-32768,-32768,-32768,   193,-32768,   -46,-32768,   153,-32768,
     153,   105,  1570,   577,   209,  1634,  1634,   680,   680,  1671,
    1704,  1736,  1767,  1797,  1826,   607,   607,   635,   635,   635,
     635,  1847,  1847,   498,   498,   522,   522,   522,   522,-32768,
     505,   697,    88,    88,   158,   275,-32768,  1570,-32768,   139,
     260,  1570,   223,    59,   196,-32768,    41,-32768,-32768,-32768,
     502,   502,   502,   502,   502,   502,-32768,-32768,-32768,-32768,
  -32768,   117,-32768,  1570,-32768,    27,-32768,-32768,-32768,-32768,
  -32768,   199,-32768,  1070,   346,-32768,   172,-32768,-32768,   213,
     158,   211,   -37,   -23,  1570,  1273,-32768,  1212,  1334,-32768,
     153,-32768,   140,  1570,  1634,  1570,-32768,-32768,   218,-32768,
  -32768,   156,   577,   245,-32768,-32768,-32768,-32768,   153,  1570,
  -32768,   247,   247,   198,   311,-32768,   155,-32768,   267,-32768,
  -32768,-32768,-32768,   999,  1141,  1570,-32768,-32768,-32768,   577,
  -32768,-32768,   224,-32768,   280,-32768,   166,   577,   577,  1393,
    1452,-32768,  1570,   139,-32768,-32768,   246,-32768,   577,-32768,
    1570,-32768,-32768,-32768,    34,  1570,  1570,-32768,-32768,-32768,
  -32768,-32768,  1570,  1570,   248,   234,   577,-32768,   320,   258,
  -32768,-32768,-32768,-32768,-32768,    18,    74,   280,-32768,-32768,
     691,   691,   577,   577,-32768,-32768,  1570,   273,   343,   277,
     277,  1570,  1570,   360,-32768,   161,  1570,   502,  1570,  1452,
  -32768,   270,   293,   303,-32768,   220,-32768,-32768,   285,-32768,
  -32768,-32768,-32768,    18,-32768,    60,-32768,   577,   603,   691,
     290,  1570,   263,-32768,   331,  1570,-32768,   340,   431,-32768,
  -32768,   220,-32768,   378,-32768,-32768,   381,-32768,-32768,-32768,
  -32768,   153,  1570,-32768,   270,   401,   406,-32768
};

static const short yypgoto[] =
{
  -32768,-32768,   398,-32768,-32768,     1,-32768,   165,-32768,   100,
     101,   154,   485,  -169,     0,   329,    97,   174,   148,-32768,
    -179,   157,   391,-32768,-32768,    81,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,    57,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    69,-32768,
  -32768,   108,-32768,    58,-32768,   121,    20,-32768,    30,-32768,
      82,-32768,-32768,-32768,-32768,   160,-32768,   259,  -287,    71,
    -182,-32768,  -204,   238,-32768,  -286,    -5,   168,   321,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
  -32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,  -163,-32768,
  -32768,-32768
};


#define	YYLAST		1893


static const short yytable[] =
{
      17,    70,    72,    17,    31,   275,   301,   338,     1,   255,
     256,    73,   342,    17,   198,    77,    73,   292,   293,  -111,
      21,    82,   281,     1,    90,    94,   -44,    91,     1,     1,
      22,    73,   296,    21,    97,    92,   297,     1,   -44,    17,
      17,   336,   -44,    22,    93,   203,    17,    17,   261,   262,
     263,   264,   265,    73,    73,   337,   119,     2,   282,   203,
     199,     1,     1,   374,   375,    83,    84,   124,  -111,    73,
     123,   311,     2,     1,   -44,   -44,   -44,     2,     2,   -44,
     -44,   -44,   -44,   -44,   -44,   171,     2,   186,   163,    17,
      17,   182,  -111,    17,    17,   192,   343,   195,   321,   322,
     323,   324,   325,    27,   327,   333,   193,   -44,    74,   -44,
       2,     2,   389,    78,   357,     1,   203,   207,     1,   195,
     164,   317,     2,   430,   200,    28,    29,    30,    96,    83,
      84,   160,   209,   161,   162,     1,   -44,   -60,   -44,   -60,
       1,   -44,   -44,   -60,   440,    86,    87,    88,   -44,   258,
     116,   117,   -44,   364,   -44,    73,     1,     1,   248,    27,
     260,   246,     1,     1,     2,   276,    17,     2,     1,    17,
     252,   170,    17,    17,   257,   202,    73,   203,   278,     1,
      73,    28,    29,    30,     2,  -262,   186,  -262,   289,     2,
     -49,   388,   -49,   -59,   -40,   -59,   -49,   295,    73,   -59,
     298,    94,   -24,   161,   162,     2,     2,   -40,   264,   265,
     -71,     2,     2,   305,   -71,   -44,   -71,     2,   125,   -44,
     345,   -44,   346,   268,   423,   269,   165,   -40,     2,   270,
     315,   -44,   -70,   -44,     1,   424,   -70,   -44,   -70,   -44,
     -40,   334,   308,   -40,   428,   307,  -267,   453,  -267,    73,
     379,   126,   239,   -41,   -40,   245,   263,   264,   265,   166,
      17,    17,    17,    17,    17,    17,   -41,   -40,   186,    94,
     -24,    17,   326,   259,   -40,   182,     1,   266,   329,    94,
     -24,   368,   -36,     2,   369,   127,   -41,   -40,   335,   370,
     340,   371,   207,   167,   380,   291,  -116,   351,  -116,   -41,
     -40,   354,   -41,   -40,   367,   381,   382,   383,   -50,   -44,
     -50,    17,   395,   272,   -50,  -120,  -120,     8,     9,    10,
     384,   306,   265,   385,   396,     2,    73,   394,   289,   363,
     412,   413,   443,   -41,   -40,   -44,   268,    -1,     1,   441,
     310,   442,   270,   -51,     1,   -51,   309,   -44,   272,   -51,
    -121,  -121,   431,    73,   415,   186,    98,    99,   100,   101,
    -122,  -122,   104,   105,   106,   107,   108,   435,   439,   111,
     112,   113,   114,   115,   448,     1,   118,   268,   121,   274,
       1,     2,   -41,   270,   268,   450,   277,     2,   444,   445,
     270,   -44,     3,     2,     4,     5,   420,   421,    73,     6,
       7,   456,   -44,   -44,   -44,    17,   457,    17,     8,     9,
      10,    76,    11,    12,   -44,   -44,   -44,   -44,   314,   -44,
     -44,    27,   268,   266,     2,   437,   332,   188,   270,     2,
     420,    80,    81,   361,    73,   362,   268,   330,   422,    -2,
       1,     1,   270,    28,    29,    30,   189,   190,   201,   328,
     377,   213,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   360,   240,   241,   242,
     243,   244,    27,   359,   187,    16,   426,   -73,    32,     2,
       2,   446,   436,     1,     3,   414,     4,     5,    16,   449,
     397,     6,     7,     1,    28,    29,    30,  -107,   417,  -107,
       8,     9,    10,  -107,    11,    75,   386,   447,   290,   320,
     121,   121,   438,   454,   102,   103,   151,   152,   153,   154,
     155,   109,   110,   304,    27,   341,   172,   156,   157,   158,
     159,   160,     2,   161,   162,   157,   158,   159,   160,   173,
     161,   162,     2,   154,   155,   407,    28,    29,    30,     0,
       5,   156,   157,   158,   159,   160,     0,   161,   162,     0,
       0,     0,   312,     0,   174,    32,     0,     0,    32,    32,
     130,     0,   131,   132,   133,   134,   135,   136,   137,     0,
       0,     0,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     261,   262,   263,   264,   265,   339,   156,   157,   158,   159,
     160,     0,   161,   162,   347,     0,   348,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     358,     0,     0,     0,     0,     0,   156,   157,   158,   159,
     160,   249,   161,   162,    32,     0,   121,   174,   174,   147,
     148,   149,   150,   151,   152,   153,   154,   155,     0,     0,
       0,     0,     0,   376,   156,   157,   158,   159,   160,     0,
     161,   162,     0,     0,     0,     0,   390,   391,     0,   135,
     136,   137,     0,   392,   393,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,     0,     0,     0,     0,   339,     0,   156,
     157,   158,   159,   160,     0,   161,   162,   427,     0,   429,
     156,   157,   158,   159,   160,     0,   161,   162,   158,   159,
     160,     0,   161,   162,     0,   174,   174,   174,   174,   174,
     174,     0,   339,     0,     0,     0,    32,     0,     0,     0,
       1,     0,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,     0,     0,   339,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,     0,     0,     0,     0,   353,     0,   -44,   -44,
     -44,   -44,   -44,     0,   -44,   -44,     0,   -44,     0,     2,
       0,     0,     0,     0,     0,     0,    80,    81,   -44,   -44,
     -44,     0,     0,     0,     0,     0,     0,     0,   -44,     0,
     -44,   -44,   -44,   -44,     0,   -44,   -44,   -44,   -44,   -44,
       1,   -44,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,
     -42,     0,     0,     0,   -42,   -42,   -42,   -42,   -42,   -42,
     -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,   -42,
     -42,   -42,     0,     0,     0,     0,     0,     0,   -42,   -42,
     -42,   -42,   -42,     0,   -42,   -42,     0,   -42,     0,     2,
     425,     0,   174,     0,     0,     0,     0,     0,   -42,   -42,
     -42,     0,     0,     0,     0,     0,     0,     0,   -42,     0,
     -42,   -42,   -42,   -42,     0,   -42,   -42,   -42,   -42,   -42,
       1,   -42,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,     0,     0,     0,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,   -44,
     -44,   -44,     0,     0,     0,     0,     0,     0,   -44,   -44,
     -44,   -44,   -44,     0,   -44,   -44,     0,   -44,     0,     2,
       0,     0,     0,     0,     0,     0,     0,     0,   -44,   -44,
     -44,     0,     0,     0,     0,     0,     0,     0,   -44,     0,
     -44,   -44,   -44,   -44,     0,   -44,   -44,   -44,   -44,   -44,
      33,   -44,     0,    34,     0,     0,     0,     0,     0,     0,
       0,    35,    36,    37,    38,     0,     0,     0,     0,     0,
       0,    39,    40,     0,     0,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,     0,    54,
       0,     0,     0,    55,    56,     0,    57,    58,    59,    60,
      61,    62,    63,    64,     0,     0,     4,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   283,    65,
       0,    33,     0,     0,    34,  -163,    66,     0,     0,  -163,
       0,  -163,    35,    36,    37,    38,     0,     0,     0,     0,
       0,     0,    39,    40,     0,     0,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,     0,
      54,     0,     0,     0,    55,    56,     0,    57,    58,    59,
      60,    61,    62,    63,    64,     0,     0,     4,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      65,     0,    33,     0,     0,    34,  -163,    66,     0,     0,
    -163,     0,  -163,    35,    36,    37,    38,     0,     0,     0,
       0,     0,     0,    39,    40,     0,     0,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
       0,    54,     0,     0,     0,    55,    56,     0,    57,    58,
      59,    60,    61,    62,    63,    64,     0,     0,     4,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    65,     0,    33,     0,     0,    34,   -35,    66,     0,
       0,   -35,     0,   -35,    35,    36,    37,    38,     0,     0,
       0,     0,     0,     0,    39,    40,     0,     0,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,     0,    54,     0,     0,     0,    55,    56,     0,    57,
      58,    59,   204,    61,    62,    63,    64,     0,     0,     4,
       0,     0,     0,     0,    33,     0,     0,    34,     0,     0,
       0,     0,    65,     0,     0,    35,    36,    37,    38,    66,
    -157,     0,     0,     0,  -157,    39,    40,     0,     0,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,     0,    54,     0,     0,     0,    55,    56,     0,
      57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
       4,     0,     0,     0,     0,    33,     0,     0,    34,     0,
       0,     0,     0,    65,     0,     0,    35,    36,    37,    38,
      66,  -159,     0,     0,     0,  -159,    39,    40,     0,     0,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,     0,    54,     0,     0,     0,    55,    56,
       0,    57,    58,    59,    60,    61,    62,    63,    64,     0,
       0,     4,     0,     0,    33,     0,     0,    34,     0,     0,
       0,     0,     0,     0,    65,    35,    36,    37,    38,     0,
       0,    66,     0,     0,  -163,    39,    40,     0,     0,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,     0,    54,     0,     0,     0,    55,    56,     0,
      57,    58,    59,    60,    61,    62,    63,    64,     0,     0,
       4,     0,     0,    33,     0,     0,    34,     0,     0,     0,
       0,     0,     0,    65,    35,    36,    37,    38,     0,     0,
      66,     0,  -163,     0,    39,    40,     0,     0,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,     0,    54,     0,     0,     0,    55,    56,     0,    57,
      58,    59,    60,    61,    62,    63,    64,     0,     0,     4,
       0,     0,    33,     0,     0,    34,     0,     0,     0,     0,
       0,     0,    65,    35,    36,    37,    38,     0,     0,    66,
    -163,     0,     0,    39,    40,     0,     0,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
       0,    54,     0,     0,     0,    55,    56,     0,    57,    58,
      59,    60,    61,    62,    63,    64,     0,     0,     4,     0,
       0,    33,     0,     0,    34,     0,     0,     0,   279,   280,
       0,    65,    35,    36,    37,    38,     0,     0,    66,     0,
       0,     0,    39,    40,     0,     0,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,     0,
      54,     0,     0,     0,    55,    56,     0,    57,    58,    59,
      60,    61,    62,    63,    64,     0,     0,     4,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      65,   133,   134,   135,   136,   137,     0,    66,     0,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,     0,     0,     0,
       0,     0,     0,   156,   157,   158,   159,   160,     0,   161,
     162,   136,   137,     0,     0,     0,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,     0,     0,     0,     0,     0,     0,
     156,   157,   158,   159,   160,   137,   161,   162,     0,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,     0,     0,     0,
       0,     0,     0,   156,   157,   158,   159,   160,     0,   161,
     162,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,     0,
       0,     0,     0,     0,     0,   156,   157,   158,   159,   160,
       0,   161,   162,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
       0,     0,     0,     0,     0,     0,   156,   157,   158,   159,
     160,     0,   161,   162,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
       0,     0,     0,     0,     0,     0,   156,   157,   158,   159,
     160,     0,   161,   162,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,     0,
       0,     0,     0,     0,     0,   156,   157,   158,   159,   160,
       0,   161,   162,   149,   150,   151,   152,   153,   154,   155,
       0,     0,     0,     0,     0,     0,   156,   157,   158,   159,
     160,     0,   161,   162
};

static const short yycheck[] =
{
       0,     6,     7,     3,     3,   184,   210,   294,     1,   172,
     173,    11,   298,    13,    31,    76,    16,   199,   200,     1,
       0,    21,   191,     1,    77,    46,     4,    77,     1,     1,
       0,    31,    78,    13,    34,    46,    82,     1,    31,    39,
      40,    78,    14,    13,    77,    82,    46,    47,     7,     8,
       9,    10,    11,    53,    54,    78,    56,    50,    79,    82,
      77,     1,     1,   349,   350,    57,    58,    67,    50,    69,
      34,   250,    50,     1,    14,    47,     4,    50,    50,     7,
       8,     9,    10,    11,    77,    85,    50,    92,     4,    89,
      90,    91,    74,    93,    94,    94,   300,    97,   261,   262,
     263,   264,   265,    42,   273,   284,    47,    47,    11,    81,
      50,    50,    78,    16,   318,     1,    82,   122,     1,   119,
      76,    80,    50,   409,    77,    64,    65,    66,    31,    57,
      58,    43,    34,    45,    46,     1,    76,    76,    78,    78,
       1,    81,    82,    82,   431,    71,    72,    73,    76,     4,
      53,    54,    80,   335,    82,   155,     1,     1,   163,    42,
      82,   161,     1,     1,    50,    79,   166,    50,     1,   169,
     169,     4,   172,   173,   174,    80,   176,    82,    79,     1,
     180,    64,    65,    66,    50,    80,   191,    82,   193,    50,
      76,   360,    78,    76,     1,    78,    82,     4,   198,    82,
      47,    46,    47,    45,    46,    50,    50,    14,    10,    11,
      76,    50,    50,     4,    80,    76,    82,    50,    14,    80,
      80,    82,    82,    76,   403,    78,    14,    34,    50,    82,
      34,    76,    76,    78,     1,    74,    80,    82,    82,    77,
      47,    69,   247,    50,   407,   245,    80,   451,    82,   249,
       4,    47,   155,     1,     1,    77,     9,    10,    11,    47,
     260,   261,   262,   263,   264,   265,    14,    14,   273,    46,
      47,   271,   271,   176,    81,   275,     1,   180,    79,    46,
      47,     1,    69,    50,     4,    81,    34,    34,    77,     9,
     295,    11,   297,    81,    48,   198,    76,    79,    78,    47,
      47,    56,    50,    50,    80,    59,    60,    61,    76,    76,
      78,   311,    78,    81,    82,    57,    58,    71,    72,    73,
      74,    46,    11,    77,     4,    50,   326,    79,   333,   334,
      57,    58,     1,    81,    81,     4,    76,     0,     1,    76,
      80,    78,    82,    76,     1,    78,   249,     4,    81,    82,
      57,    58,    82,   353,    77,   360,    35,    36,    37,    38,
      57,    58,    41,    42,    43,    44,    45,    82,    78,    48,
      49,    50,    51,    52,    34,     1,    55,    76,    57,    78,
       1,    50,     4,    82,    76,     4,    78,    50,    57,    58,
      82,    48,    55,    50,    57,    58,   401,   402,   398,    62,
      63,     0,    59,    60,    61,   405,     0,   407,    71,    72,
      73,    13,    75,    76,    71,    72,    73,    74,   253,    76,
      77,    42,    76,   326,    50,   425,    80,    48,    82,    50,
     435,    57,    58,   333,   434,   334,    76,   283,    78,     0,
       1,     1,    82,    64,    65,    66,    67,    68,   119,   275,
     353,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   328,   156,   157,   158,
     159,   160,    42,   326,    93,     0,   405,    47,     3,    50,
      50,   434,   423,     1,    55,   398,    57,    58,    13,   441,
     379,    62,    63,     1,    64,    65,    66,    76,   400,    78,
      71,    72,    73,    82,    75,    76,   356,   435,   197,   260,
     199,   200,   425,   452,    39,    40,    28,    29,    30,    31,
      32,    46,    47,   212,    42,   297,    34,    39,    40,    41,
      42,    43,    50,    45,    46,    40,    41,    42,    43,    47,
      45,    46,    50,    31,    32,   387,    64,    65,    66,    -1,
      58,    39,    40,    41,    42,    43,    -1,    45,    46,    -1,
      -1,    -1,   251,    -1,    89,    90,    -1,    -1,    93,    94,
       3,    -1,     5,     6,     7,     8,     9,    10,    11,    -1,
      -1,    -1,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
       7,     8,     9,    10,    11,   294,    39,    40,    41,    42,
      43,    -1,    45,    46,   303,    -1,   305,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
     319,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,   166,    45,    46,   169,    -1,   335,   172,   173,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    -1,    -1,
      -1,    -1,    -1,   352,    39,    40,    41,    42,    43,    -1,
      45,    46,    -1,    -1,    -1,    -1,   365,   366,    -1,     9,
      10,    11,    -1,   372,   373,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    -1,    -1,    -1,    -1,   396,    -1,    39,
      40,    41,    42,    43,    -1,    45,    46,   406,    -1,   408,
      39,    40,    41,    42,    43,    -1,    45,    46,    41,    42,
      43,    -1,    45,    46,    -1,   260,   261,   262,   263,   264,
     265,    -1,   431,    -1,    -1,    -1,   271,    -1,    -1,    -1,
       1,    -1,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    -1,    -1,   452,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,   311,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,    57,    58,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      71,    72,    73,    74,    -1,    76,    77,    78,    79,    80,
       1,    82,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    -1,    50,
     405,    -1,   407,    -1,    -1,    -1,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      71,    72,    73,    74,    -1,    76,    77,    78,    79,    80,
       1,    82,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    -1,    -1,    -1,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    -1,    -1,    -1,    -1,    -1,    -1,    39,    40,
      41,    42,    43,    -1,    45,    46,    -1,    48,    -1,    50,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    59,    60,
      61,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    -1,
      71,    72,    73,    74,    -1,    76,    77,    78,    79,    80,
       1,    82,    -1,     4,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    12,    13,    14,    15,    -1,    -1,    -1,    -1,    -1,
      -1,    22,    23,    -1,    -1,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    -1,    40,
      -1,    -1,    -1,    44,    45,    -1,    47,    48,    49,    50,
      51,    52,    53,    54,    -1,    -1,    57,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    69,    70,
      -1,     1,    -1,    -1,     4,    76,    77,    -1,    -1,    80,
      -1,    82,    12,    13,    14,    15,    -1,    -1,    -1,    -1,
      -1,    -1,    22,    23,    -1,    -1,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    57,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,    -1,     1,    -1,    -1,     4,    76,    77,    -1,    -1,
      80,    -1,    82,    12,    13,    14,    15,    -1,    -1,    -1,
      -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    57,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    70,    -1,     1,    -1,    -1,     4,    76,    77,    -1,
      -1,    80,    -1,    82,    12,    13,    14,    15,    -1,    -1,
      -1,    -1,    -1,    -1,    22,    23,    -1,    -1,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    57,
      -1,    -1,    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,
      -1,    -1,    70,    -1,    -1,    12,    13,    14,    15,    77,
      78,    -1,    -1,    -1,    82,    22,    23,    -1,    -1,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      57,    -1,    -1,    -1,    -1,     1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,    70,    -1,    -1,    12,    13,    14,    15,
      77,    78,    -1,    -1,    -1,    82,    22,    23,    -1,    -1,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,
      -1,    47,    48,    49,    50,    51,    52,    53,    54,    -1,
      -1,    57,    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,
      -1,    -1,    -1,    -1,    70,    12,    13,    14,    15,    -1,
      -1,    77,    -1,    -1,    80,    22,    23,    -1,    -1,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,
      47,    48,    49,    50,    51,    52,    53,    54,    -1,    -1,
      57,    -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,    -1,    -1,    70,    12,    13,    14,    15,    -1,    -1,
      77,    -1,    79,    -1,    22,    23,    -1,    -1,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,
      48,    49,    50,    51,    52,    53,    54,    -1,    -1,    57,
      -1,    -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    -1,
      -1,    -1,    70,    12,    13,    14,    15,    -1,    -1,    77,
      78,    -1,    -1,    22,    23,    -1,    -1,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      -1,    40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,
      49,    50,    51,    52,    53,    54,    -1,    -1,    57,    -1,
      -1,     1,    -1,    -1,     4,    -1,    -1,    -1,    67,    68,
      -1,    70,    12,    13,    14,    15,    -1,    -1,    77,    -1,
      -1,    -1,    22,    23,    -1,    -1,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    -1,
      40,    -1,    -1,    -1,    44,    45,    -1,    47,    48,    49,
      50,    51,    52,    53,    54,    -1,    -1,    57,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      70,     7,     8,     9,    10,    11,    -1,    77,    -1,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    10,    11,    -1,    -1,    -1,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    -1,    -1,    -1,    -1,    -1,    -1,
      39,    40,    41,    42,    43,    11,    45,    46,    -1,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    -1,    -1,    -1,
      -1,    -1,    -1,    39,    40,    41,    42,    43,    -1,    45,
      46,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    -1,
      -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,    43,
      -1,    45,    46,    26,    27,    28,    29,    30,    31,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    39,    40,    41,    42,
      43,    -1,    45,    46
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/bison/bison.simple"

/* Skeleton output parser for bison,

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software
   Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* This is the parser code that is written into each bison parser when
   the %semantic_parser declaration is not specified in the grammar.
   It was written by Richard Stallman by simplifying the hairy parser
   used when %semantic_parser is specified.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

#if ! defined (yyoverflow) || defined (YYERROR_VERBOSE)

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || defined (YYERROR_VERBOSE) */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
# if YYLSP_NEEDED
  YYLTYPE yyls;
# endif
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# if YYLSP_NEEDED
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAX)
# else
#  define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)
# endif

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif


#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	goto yyacceptlab
#define YYABORT 	goto yyabortlab
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).

   When YYLLOC_DEFAULT is run, CURRENT is set the location of the
   first token.  By default, to implement support for ranges, extend
   its range to the last symbol.  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)       	\
   Current.last_line   = Rhs[N].last_line;	\
   Current.last_column = Rhs[N].last_column;
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#if YYPURE
# if YYLSP_NEEDED
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, &yylloc, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval, &yylloc)
#  endif
# else /* !YYLSP_NEEDED */
#  ifdef YYLEX_PARAM
#   define YYLEX		yylex (&yylval, YYLEX_PARAM)
#  else
#   define YYLEX		yylex (&yylval)
#  endif
# endif /* !YYLSP_NEEDED */
#else /* !YYPURE */
# define YYLEX			yylex ()
#endif /* !YYPURE */


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif

#ifdef YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif
#endif

#line 315 "/usr/share/bison/bison.simple"


/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif

/* YY_DECL_VARIABLES -- depending whether we use a pure parser,
   variables are global, or local to YYPARSE.  */

#define YY_DECL_NON_LSP_VARIABLES			\
/* The lookahead symbol.  */				\
int yychar;						\
							\
/* The semantic value of the lookahead symbol. */	\
YYSTYPE yylval;						\
							\
/* Number of parse errors so far.  */			\
int yynerrs;

#if YYLSP_NEEDED
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES			\
						\
/* Location data for the lookahead symbol.  */	\
YYLTYPE yylloc;
#else
# define YY_DECL_VARIABLES			\
YY_DECL_NON_LSP_VARIABLES
#endif


/* If nonreentrant, generate the variables here. */

#if !YYPURE
YY_DECL_VARIABLES
#endif  /* !YYPURE */

int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* If reentrant, generate the variables here. */
#if YYPURE
  YY_DECL_VARIABLES
#endif  /* !YYPURE */

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack. */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;

#if YYLSP_NEEDED
  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
#endif

#if YYLSP_NEEDED
# define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
# define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  YYSIZE_T yystacksize = YYINITDEPTH;


  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
#if YYLSP_NEEDED
  YYLTYPE yyloc;
#endif

  /* When reducing, the number of symbols on the RHS of the reduced
     rule. */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
#if YYLSP_NEEDED
  yylsp = yyls;
#endif
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  */
# if YYLSP_NEEDED
	YYLTYPE *yyls1 = yyls;
	/* This used to be a conditional around just the two extra args,
	   but that might be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
# else
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);
# endif
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
# if YYLSP_NEEDED
	YYSTACK_RELOCATE (yyls);
# endif
# undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
#if YYLSP_NEEDED
      yylsp = yyls + yysize - 1;
#endif

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

#if YYDEBUG
     /* We have to keep this `#if YYDEBUG', since we use variables
	which are defined only if `YYDEBUG' is set.  */
      if (yydebug)
	{
	  YYFPRINTF (stderr, "Next token is %d (%s",
		     yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise
	     meaning of a token, for further debugging info.  */
# ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
# endif
	  YYFPRINTF (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to the semantic value of
     the lookahead token.  This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

#if YYLSP_NEEDED
  /* Similarly for the default location.  Let the user run additional
     commands if for instance locations are ranges.  */
  yyloc = yylsp[1-yylen];
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
#endif

#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] > 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif

  switch (yyn) {

case 3:
#line 617 "parser/maria.y"
{ pnwarn ("extraneous semicolon"); ;
    break;}
case 4:
#line 620 "parser/maria.y"
{ pnwarn ("extraneous semicolon"); ;
    break;}
case 14:
#line 645 "parser/maria.y"
{
	  if (yyvsp[0].s && theNet.getType (yyvsp[0].s)) {
	    thePrinter.printRaw ("ignoring redefinition of type ");
	    thePrinter.printQuoted (yyvsp[0].s);
	    thePrinter.finish ();
	    pnerrors++;
	    deleteType (yyvsp[-1].type); delete[] yyvsp[0].s;
	  }
	  else if (yyvsp[-1].type && yyvsp[0].s) {
	    checkName (yyvsp[0].s, ckType, "invalid type name ");
	    theNet.addType (*yyvsp[-1].type, yyvsp[0].s);
	  }
	  else {
	    deleteType (yyvsp[-1].type); delete[] yyvsp[0].s;
	  }
	;
    break;}
case 15:
#line 665 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 16:
#line 668 "parser/maria.y"
{ yyval.flag = true; ;
    break;}
case 17:
#line 671 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("ignoring extraneous `queue'"); ;
    break;}
case 18:
#line 674 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("ignoring extraneous `stack'"); ;
    break;}
case 19:
#line 679 "parser/maria.y"
{
	  if (!(yyval.type = yyvsp[-1].type))
	    yyval.type = new class StructType (*new class ComponentList);
	;
    break;}
case 20:
#line 685 "parser/maria.y"
{
	  if (numberParsed && yyvsp[-1].i > 0)
	    yyval.type = new class IdType (yyvsp[-1].i);
	  else {
	    if (numberParsed)
	      pnerror ("empty identifier pool");
	    yyval.type = NULL;
	  }
	;
    break;}
case 21:
#line 696 "parser/maria.y"
{ yyval.type = yyvsp[-1].componentList ? new class StructType (*yyvsp[-1].componentList) : NULL; emptyParsed = false; ;
    break;}
case 22:
#line 699 "parser/maria.y"
{
	  if (yyvsp[-1].componentList && !yyvsp[-1].componentList->getSize ()) {
	    pnerror ("missing component list for union");
	    delete yyvsp[-1].componentList, yyval.type = NULL;
	  }
	  else
	    yyval.type = yyvsp[-1].componentList ? new class UnionType (*yyvsp[-1].componentList) : NULL;

	  emptyParsed = false;
	;
    break;}
case 23:
#line 711 "parser/maria.y"
{ yyval.type = yyvsp[0].type; ;
    break;}
case 24:
#line 714 "parser/maria.y"
{ currentType = yyvsp[0].type; ;
    break;}
case 25:
#line 716 "parser/maria.y"
{
	  if ((yyval.type = yyvsp[-2].type) && yyvsp[0].constraint) {
	    yyval.type = copyType (yyval.type);
	    if (class Constraint* c = yyval.type->getConstraint ()) {
	      if (c->isDisjoint (*yyvsp[0].constraint)) {
		pnerror ("ignoring constraint that would make the type empty");
		delete yyvsp[0].constraint;
	      }
	      else
		c->restrict (*yyvsp[0].constraint, *yyval.type);
	    }
	    else
	      yyval.type->setConstraint (*yyvsp[0].constraint);
	  }
 	  else
 	    delete yyvsp[0].constraint;
	  currentType = NULL;
	;
    break;}
case 26:
#line 736 "parser/maria.y"
{
	  if (yyvsp[-1].type && !isOrdered (*yyvsp[-1].type)) {
	    deleteType (yyvsp[-3].type), deleteType (yyvsp[-1].type), yyval.type = NULL;
	  }
	  else if (yyvsp[-3].type && yyvsp[-1].type) {
	    card_t size = yyvsp[-1].type->getNumValues ();
	    if (!size || size == CARD_T_MAX || (maxIndex && size > maxIndex)) {
	      thePrinter.printRaw ("type ");
	      printType (*yyvsp[-1].type);
	      thePrinter.printRaw (" has too big domain for indexing");
	      if (size && size < CARD_T_MAX)
		thePrinter.printRaw (" (try -a0)");
	      thePrinter.finish ();
	      pnerrors++;
	      deleteType (yyvsp[-3].type), deleteType (yyvsp[-1].type), yyval.type = NULL;
	    }
	    else {
	      theNet.addType (*yyvsp[-3].type); theNet.addType (*yyvsp[-1].type);
	      yyval.type = new class VectorType (*yyvsp[-3].type, *yyvsp[-1].type);
	    }
	  }
	  else
	    deleteType (yyvsp[-3].type), deleteType (yyvsp[-1].type), yyval.type = NULL;
	;
    break;}
case 27:
#line 762 "parser/maria.y"
{
	  if (yyvsp[-4].type && numberParsed) {
	    if (!yyvsp[-1].i) {
	      pnerror ("empty buffer");
	      deleteType (yyvsp[-4].type), yyval.type = NULL;
	    }
	    else {
	      theNet.addType (*yyvsp[-4].type);
	      yyval.type = new class BufferType (*yyvsp[-4].type, yyvsp[-1].i, yyvsp[-2].flag);
	    }
	  }
	  else
	    deleteType (yyvsp[-4].type), yyval.type = NULL;
	;
    break;}
case 28:
#line 778 "parser/maria.y"
{
	  pnerror ("array dimension must be an ordered type");
	  deleteType (yyvsp[-3].type), yyval.type = NULL;
	;
    break;}
case 29:
#line 786 "parser/maria.y"
{ yyval.constraint = yyvsp[-1].constraint; ;
    break;}
case 30:
#line 791 "parser/maria.y"
{
 	  if ((yyval.constraint = yyvsp[-2].constraint) && yyvsp[0].range)
 	    yyval.constraint->append (*yyvsp[0].range);
 	  else
	    delete yyvsp[0].range;
	;
    break;}
case 31:
#line 799 "parser/maria.y"
{ if (yyvsp[0].range) (yyval.constraint = new class Constraint)->append (*yyvsp[0].range); else yyval.constraint = NULL; ;
    break;}
case 32:
#line 804 "parser/maria.y"
{ yyval.range = yyvsp[0].value ? new class Range (*yyvsp[0].value, *yyvsp[0].value) : NULL; ;
    break;}
case 33:
#line 807 "parser/maria.y"
{ yyval.range = yyvsp[0].value ? new class Range (currentType->getFirstValue (), *yyvsp[0].value) : 0; ;
    break;}
case 34:
#line 810 "parser/maria.y"
{
 	  if (yyvsp[-2].value && yyvsp[0].value) {
	    if (pnwarnings && *yyvsp[0].value < *yyvsp[-2].value)
	      pnwarn ("upper limit of range specified before lower limit");
 	    yyval.range = new class Range (*yyvsp[-2].value, *yyvsp[0].value);
	  }
	  else {
	    yyval.range = NULL; delete yyvsp[-2].value; delete yyvsp[0].value;
	  }
	;
    break;}
case 35:
#line 822 "parser/maria.y"
{ yyval.range = yyvsp[-1].value ? new class Range (*yyvsp[-1].value, currentType->getLastValue ()) : 0; ;
    break;}
case 36:
#line 827 "parser/maria.y"
{ yyval.value = ensureConstant (yyvsp[0].expr, currentType); ;
    break;}
case 37:
#line 832 "parser/maria.y"
{ yyval.value = ensureConstant (yyvsp[0].expr, currentType); ;
    break;}
case 38:
#line 837 "parser/maria.y"
{
	  if (!yyvsp[0].s) yyval.type = NULL;
	  else if ((yyval.type = const_cast<class Type*>(theNet.getType (yyvsp[0].s))));
	  else if (!strcmp (yyvsp[0].s, "bool"))
	    yyval.type = &const_cast<class BoolType&>(Net::getBoolType ());
	  else if (!strcmp (yyvsp[0].s, "int"))
	    yyval.type = &const_cast<class IntType&>(Net::getIntType ());
	  else if (!strcmp (yyvsp[0].s, "unsigned"))
	    yyval.type = &const_cast<class CardType&>(Net::getCardType ());
	  else if (!strcmp (yyvsp[0].s, "char"))
	    yyval.type = &const_cast<class CharType&>(Net::getCharType ());
	  else {
	    thePrinter.printRaw ("undefined type ");
	    thePrinter.printQuoted (yyvsp[0].s);
	    thePrinter.finish ();
	    pnerrors++;
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 39:
#line 860 "parser/maria.y"
{
	  yyval.i = 0; numberParsed = false;

	  if (yyvsp[0].expr && yyvsp[0].expr->getType () && (yyvsp[0].expr = fold (yyvsp[0].expr)) &&
	      yyvsp[0].expr->getKind () == Expression::eConstant) {
	    const class Valuation empty;
	    class Value* v = yyvsp[0].expr->eval (empty);
	    assert (v && yyvsp[0].expr->getType ()->isConstrained (*v));
	    switch (v->getType ().getKind ()) {
	    case Type::tChar:
	      yyval.i = char_t (static_cast<const class LeafValue&>(*v));
	      if (pnwarnings) {
		thePrinter.printRaw ("Warning:converting ");
		thePrinter.print (char_t (yyval.i));
		thePrinter.printRaw (" to ");
		thePrinter.print (yyval.i);
		thePrinter.finish ();
	      }
	      break;
	    case Type::tInt:
	      numberParsed = true;
	      yyval.i = int_t (static_cast<const class LeafValue&>(*v));
	      if (pnwarnings) {
		thePrinter.printRaw ("Warning:converting ");
		thePrinter.print (int_t (yyval.i));
		thePrinter.printRaw (" to ");
		thePrinter.print (yyval.i);
		thePrinter.finish ();
	      }
	      break;
	    case Type::tCard:
	      numberParsed = true;
	      yyval.i = card_t (static_cast<const class LeafValue&>(*v));
	      break;
	    case Type::tEnum:
	      numberParsed = true;
	      yyval.i = card_t (static_cast<const class LeafValue&>(*v));
	      break;
	    default:
	      pnerror ("expression does not evaluate to a number");
	      break;
	    }

	    delete v;
	  }
	  else if (yyvsp[0].expr)
	    pnerror ("number expected, got expression");

	  yyvsp[0].expr->destroy ();
	;
    break;}
case 40:
#line 914 "parser/maria.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 41:
#line 917 "parser/maria.y"
{ yyval.s = NULL; ;
    break;}
case 42:
#line 921 "parser/maria.y"
{ yyval.s = NULL; ;
    break;}
case 43:
#line 924 "parser/maria.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 44:
#line 928 "parser/maria.y"
{ pnerror ("missing name"); yyval.s = NULL; ;
    break;}
case 45:
#line 931 "parser/maria.y"
{ yyval.s = yyvsp[0].s; ;
    break;}
case 46:
#line 936 "parser/maria.y"
{
	  if ((yyval.s = yyvsp[0].s))
	    checkName (yyval.s, ckEnum, "invalid enumeration constant name ");
	;
    break;}
case 49:
#line 948 "parser/maria.y"
{ yyval.type = NULL; pnerror ("missing enumeration value"); ;
    break;}
case 50:
#line 951 "parser/maria.y"
{
	  if (yyvsp[0].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type =
							 new class EnumType),
			    yyvsp[0].s);
	  else
	    yyval.type = NULL;
	;
    break;}
case 51:
#line 961 "parser/maria.y"
{
	  if (!(yyval.type = yyvsp[-2].type) && yyvsp[0].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type =
							 new class EnumType),
			    yyvsp[0].s);
	  else if (yyval.type && yyvsp[0].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type), yyvsp[0].s);
	;
    break;}
case 52:
#line 971 "parser/maria.y"
{
	  if (yyvsp[-2].s && numberParsed)
	    addEnumeration (static_cast<class EnumType*>(yyval.type =
							 new class EnumType),
			    yyvsp[-2].s, yyvsp[0].i);
	  else {
	    yyval.type = NULL; delete[] yyvsp[-2].s;
	  }
	;
    break;}
case 53:
#line 982 "parser/maria.y"
{
	  if (!numberParsed) {
	    yyval.type = yyvsp[-4].type; delete[] yyvsp[-2].s;
	  }
	  else if (!(yyval.type = yyvsp[-4].type) && yyvsp[-2].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type =
							 new class EnumType),
			    yyvsp[-2].s, yyvsp[0].i);
	  else if (yyval.type && yyvsp[-2].s)
	    addEnumeration (static_cast<class EnumType*>(yyval.type), yyvsp[-2].s, yyvsp[0].i);
	;
    break;}
case 56:
#line 999 "parser/maria.y"
{
	  if ((yyval.s = yyvsp[0].s))
	    checkName (yyval.s, ckComp, "invalid component name ");
	;
    break;}
case 57:
#line 1007 "parser/maria.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s) {
	    (yyval.componentList = new class ComponentList)->addComponent (yyvsp[0].s, *yyvsp[-1].type);
	    theNet.addType (*yyvsp[-1].type);
	  }
	  else {
	    deleteType (yyvsp[-1].type);
	    delete[] yyvsp[0].s;
	    yyval.componentList = NULL;
	  }

	  emptyParsed = false;
	;
    break;}
case 58:
#line 1022 "parser/maria.y"
{
	  if ((yyval.componentList = yyvsp[-3].componentList) && yyvsp[-1].type && yyvsp[0].s) {
	    if (emptyParsed)
	      pnerror ("extraneous delimiter in component list");

	    emptyParsed = false;

	    if ((*yyval.componentList)[yyvsp[0].s]) {
	      thePrinter.printRaw ("ignoring redefinition of component ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	      deleteType (yyvsp[-1].type);
	      delete[] yyvsp[0].s;
	    }
	    else {
	      yyval.componentList->addComponent (yyvsp[0].s, *yyvsp[-1].type);
	      theNet.addType (*yyvsp[-1].type);
	    }
	  }
	  else {
	    delete yyval.componentList;
	    deleteType (yyvsp[-1].type);
	    delete[] yyvsp[0].s;
	    yyval.componentList = NULL;
	  }
	;
    break;}
case 59:
#line 1051 "parser/maria.y"
{
	  yyval.componentList = yyvsp[-1].componentList;
	  if (emptyParsed)
	    pnerror ("extraneous delimiter in component list");
	  emptyParsed = true;
	;
    break;}
case 60:
#line 1058 "parser/maria.y"
{ yyval.componentList = new class ComponentList; emptyParsed = true; ;
    break;}
case 63:
#line 1069 "parser/maria.y"
{
	  if ((yyval.s = yyvsp[0].s))
	    checkName (yyvsp[0].s, ckFunc, "invalid function name ");
	;
    break;}
case 64:
#line 1077 "parser/maria.y"
{ currentType = yyvsp[-2].type; ;
    break;}
case 65:
#line 1079 "parser/maria.y"
{ defun (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr); ;
    break;}
case 66:
#line 1082 "parser/maria.y"
{
	  currentType = yyvsp[-4].type;
	  if (emptyParsed && currentArity)
	    pnerror ("extraneous delimiter after formal parameter list");
	  emptyParsed = false;
	;
    break;}
case 67:
#line 1089 "parser/maria.y"
{ defun (yyvsp[-6].type, yyvsp[-5].s, yyvsp[0].expr); ;
    break;}
case 68:
#line 1094 "parser/maria.y"
{
	  if (currentArity || currentParameters)
	    delete[] yyvsp[0].s;
	  else
	    addParameter (yyvsp[-1].type, yyvsp[0].s), emptyParsed = false;
	;
    break;}
case 69:
#line 1102 "parser/maria.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s && emptyParsed)
	    pnerror ("extraneous delimiter in parameter list");
	  addParameter (yyvsp[-1].type, yyvsp[0].s);
	  emptyParsed = false;
	;
    break;}
case 70:
#line 1110 "parser/maria.y"
{
	  if (emptyParsed)
	    pnerror ("extraneous delimiter in parameter list");
	  emptyParsed = true;
	;
    break;}
case 71:
#line 1116 "parser/maria.y"
{ if (!currentArity && !currentParameters) emptyParsed = true; ;
    break;}
case 72:
#line 1120 "parser/maria.y"
{ yyval.constraint = NULL; ;
    break;}
case 73:
#line 1123 "parser/maria.y"
{ currentType = &Net::getCardType (); ;
    break;}
case 74:
#line 1125 "parser/maria.y"
{
	  if (!(yyval.constraint = yyvsp[-2].constraint))
	    yyval.constraint = yyvsp[0].constraint;
	  else {
	    if (yyval.constraint->isDisjoint (*yyvsp[0].constraint)) {
	      pnerror ("ignoring contradictory capacity constraint");
	      delete yyvsp[-2].constraint; delete yyvsp[0].constraint;
	      yyval.constraint = NULL;
	    }
	    else {
	      yyval.constraint->restrict (*yyvsp[0].constraint, *currentType); delete yyvsp[0].constraint;
	    }
	  }
	  currentType = NULL;
	;
    break;}
case 75:
#line 1143 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 76:
#line 1146 "parser/maria.y"
{ if (yyvsp[-1].flag) pnerror ("ignoring extraneous `const'"); yyval.flag = true; ;
    break;}
case 77:
#line 1151 "parser/maria.y"
{
	  currentPlace = NULL;
	  if ((currentType = yyvsp[-1].type))
	    theNet.addType (*yyvsp[-1].type);

	  if (yyvsp[-3].s && yyvsp[-1].type) {
	    if (theNet.getPlace (yyvsp[-3].s)) {
	      thePrinter.printRaw ("ignoring redefinition of place ");
	      thePrinter.printQuoted (yyvsp[-3].s);
	      thePrinter.finish ();
	      pnerrors++;
	      delete[] yyvsp[-3].s; delete yyvsp[-2].constraint;
	    }
	    else {
	      checkName (yyvsp[-3].s, ckPlace, "invalid place name ");
	      (currentPlace = &theNet.addPlace (yyvsp[-3].s, yyvsp[-2].constraint, *yyvsp[-1].type))
		->setConstant (yyvsp[0].flag);
	    }
	  }
	  else {
	    delete[] yyvsp[-3].s; delete yyvsp[-2].constraint;
	  }
	;
    break;}
case 78:
#line 1175 "parser/maria.y"
{
	  if (currentPlace && yyvsp[0].marking)
	    currentPlace->setInitMarking (*yyvsp[0].marking);
	  else
	    yyvsp[0].marking->destroy ();
	  currentType = NULL, currentPlace = NULL;
	;
    break;}
case 79:
#line 1186 "parser/maria.y"
{
	  if (yyvsp[0].s) {
	    if (!(yyval.place = const_cast<class Place*>(theNet.getPlace (yyvsp[0].s)))) {
	      thePrinter.printRaw ("undefined place ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	  else
	    yyval.place = NULL;
	  delete[] yyvsp[0].s;
	;
    break;}
case 80:
#line 1202 "parser/maria.y"
{ yyval.marking = NULL; ;
    break;}
case 81:
#line 1205 "parser/maria.y"
{
	  if (!(yyval.marking = yyvsp[-2].marking))
	    yyval.marking = yyvsp[0].marking;
	  else {
	    pnerror ("multiple init blocks"); yyvsp[0].marking->destroy ();
	  }
	  Expression::clear ();
	;
    break;}
case 82:
#line 1216 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 83:
#line 1219 "parser/maria.y"
{ if (yyvsp[-1].flag) pnerror ("ignoring extraneous `:'"); yyval.flag = true; ;
    break;}
case 84:
#line 1223 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 85:
#line 1226 "parser/maria.y"
{ if (yyvsp[-1].flag) pnerror ("ignoring extraneous `!'"); yyval.flag = true; ;
    break;}
case 86:
#line 1231 "parser/maria.y"
{
	  if (yyvsp[-1].s) {
	    if ((currentTransition = yyvsp[-2].flag
		 ? theNet.getCallee (yyvsp[-1].s)
		 : theNet.getTransition (yyvsp[-1].s))) {
	      pnwarn ("augmenting transition definition");
	      delete[] yyvsp[-1].s;
	    }
	    else {
	      if (!yyvsp[-2].flag) checkName (yyvsp[-1].s, ckTrans, "invalid transition name ");
	      currentTransition = &theNet.addTransition (yyvsp[-1].s, yyvsp[-2].flag);
	    }
	    if (yyvsp[0].flag)
	      currentTransition->setPriority (theNet.getMaxPriority ());
	  }
	  else
	    currentTransition = NULL;
	;
    break;}
case 87:
#line 1250 "parser/maria.y"
{
	  Expression::clear ();
	  if (currentTransition && !yyvsp[-4].flag) {
	    if (const class QuantifierList* q =
		currentTransition->getOutputVariables ()) {
	      for (QuantifierList::const_iterator i = q->begin ();
		   i != q->end (); i++) {
		const class VariableDefinition& v = (*i)->getVariable ();

		if (currentTransition->isInput (&v)) {
		  thePrinter.printRaw ("output variable ");
		  thePrinter.printQuoted (v.getName ());
		  thePrinter.printRaw (" encountered on an input arc");
		  thePrinter.finish ();
		  pnerrors++;
		}
		if (currentTransition->isGate (&v)) {
		  thePrinter.printRaw ("output variable ");
		  thePrinter.printQuoted (v.getName ());
		  thePrinter.printRaw (" encountered on a gate");
		  thePrinter.finish ();
		  pnerrors++;
		}
		if (!currentTransition->isOutput (&v)) {
		  thePrinter.printRaw ("output variable ");
		  thePrinter.printQuoted (v.getName ());
		  thePrinter.printRaw (" not used on output arcs");
		  thePrinter.finish ();
		  pnerrors++;
		}
	      }
	    }
	    if (currentTransition->isInput (0)) {
	      thePrinter.printRaw ("an input arc refers to place contents");
	      thePrinter.finish ();
	      pnerrors++;
	    }
	    if (currentTransition->isGate (0)) {
	      thePrinter.printRaw ("a gate refers to place contents");
	      thePrinter.finish ();
	      pnerrors++;
	    }
	    if (!currentTransition->hasInputs () &&
		currentTransition->hasOutputs ())
	      pnwarn ("transition has output arcs but no inputs");
	    if (!currentTransition->isUnifiable (thePrinter))
	      pnerror ("transition cannot be unified");
	  }
	  currentTransition = NULL;
	;
    break;}
case 88:
#line 1304 "parser/maria.y"
{
	  if (yyvsp[0].s) {
	    if (!(yyval.trans = const_cast<class Transition*>(theNet.getTransition
						     (yyvsp[0].s)))) {
	      thePrinter.printRaw ("undefined transition ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	  else
	    yyval.trans = NULL;
	  delete[] yyvsp[0].s;
	;
    break;}
case 91:
#line 1325 "parser/maria.y"
{ isOutputArc = false; ;
    break;}
case 93:
#line 1329 "parser/maria.y"
{ isOutputArc = true; ;
    break;}
case 95:
#line 1333 "parser/maria.y"
{ currentType = &Net::getBoolType (); ;
    break;}
case 96:
#line 1335 "parser/maria.y"
{ currentType = NULL; ;
    break;}
case 97:
#line 1338 "parser/maria.y"
{ currentContextTransition = currentTransition; ;
    break;}
case 98:
#line 1340 "parser/maria.y"
{
	  if (currentTransition &&
	      ((yyvsp[0].expr && yyvsp[0].expr->getKind () == Expression::eMarking &&
		yyvsp[0].expr->getType () && yyvsp[0].expr->getType ()->getKind () == Type::tBool) ||
	      (yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr))))) {
	    if (!theNet.addConstraint (*yyvsp[0].expr->cse (), *currentTransition,
				       static_cast<enum Net::CKind>(yyvsp[-2].i)))
	      pnerror ("error in constraint");
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  currentContextTransition = NULL;
	;
    break;}
case 99:
#line 1355 "parser/maria.y"
{ currentContextTransition = currentTransition; ;
    break;}
case 100:
#line 1357 "parser/maria.y"
{
	  if (currentTransition && (yyvsp[0].expr = ensureBool (yyvsp[0].expr)))
	    currentTransition->addHide (*yyvsp[0].expr->cse ());
	  else
	    yyvsp[0].expr->destroy ();
	  currentContextTransition = NULL;
	;
    break;}
case 101:
#line 1366 "parser/maria.y"
{
	  if (!currentTransition || !yyvsp[0].s);
	  else if (const class Transition* t = theNet.getCallee (yyvsp[0].s)) {
	    if (!currentTransition->fuse (theNet, *t, thePrinter, pnwarnings))
	      pnerrors++;
	  }
	  else {
	    thePrinter.printRaw (":trans ");
	    thePrinter.printQuoted (yyvsp[0].s);
	    thePrinter.printRaw (" not found");
	    thePrinter.finish ();
	    pnerrors++;
	  }
	  delete[] yyvsp[0].s;
	;
    break;}
case 102:
#line 1383 "parser/maria.y"
{
	  if (pnwarnings && currentTransition &&
	      currentTransition->getPriority ()) {
	    thePrinter.printRaw ("redefining priority");
	    thePrinter.finish ();
	  }
	  if (currentTransition) currentTransition->setPriority (yyvsp[0].i);
	;
    break;}
case 103:
#line 1394 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 104:
#line 1397 "parser/maria.y"
{ yyval.flag = true; ;
    break;}
case 105:
#line 1400 "parser/maria.y"
{
	  if (!yyvsp[-2].flag)
	    pnerror ("extraneous delimiter before variable definition");
	  yyval.flag = true;
	;
    break;}
case 106:
#line 1407 "parser/maria.y"
{
	  if (!yyvsp[-1].flag)
	    pnerror ("extraneous delimiter in variable definition list");
	  yyval.flag = false;
	;
    break;}
case 107:
#line 1416 "parser/maria.y"
{
	  if (yyvsp[-1].type && yyvsp[0].s && currentTransition) {
	    if (currentTransition->getVariable (yyvsp[0].s)) {
	      thePrinter.printRaw ("redefinition of variable ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	      delete[] yyvsp[0].s;
	    }
	    else {
	      currentTransition->addVariable (yyvsp[0].s, *yyvsp[-1].type, false, yyvsp[-2].flag);
	      checkName (yyvsp[0].s, ckVar, "invalid variable name ");
	      if (pnwarnings) {
		if (getConstant (yyvsp[0].s) || getConstantFunction (yyvsp[0].s)) {
		  thePrinter.printRaw ("Warning:variable ");
		  thePrinter.printQuoted (yyvsp[0].s);
		  thePrinter.printRaw (" shadows a constant");
		  thePrinter.finish ();
		}
		else if (theNet.getType (yyvsp[0].s)) {
		  thePrinter.printRaw ("Warning:variable ");
		  thePrinter.printQuoted (yyvsp[0].s);
		  thePrinter.printRaw (" shadows a type name");
		  thePrinter.finish ();
		}
	      }
	    }
	  }
	  else
	    delete[] yyvsp[0].s;
	;
    break;}
case 108:
#line 1449 "parser/maria.y"
{ beginAny (yyvsp[-2].type, yyvsp[-1].s, yyvsp[-3].flag); ;
    break;}
case 109:
#line 1451 "parser/maria.y"
{ endAny (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr)->destroy (); ;
    break;}
case 110:
#line 1454 "parser/maria.y"
{ if (yyvsp[-1].flag) pnerror ("ignoring meaningless `hide'"); ;
    break;}
case 111:
#line 1458 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 112:
#line 1461 "parser/maria.y"
{ yyval.flag = true; if (yyvsp[-1].flag) pnerror ("ignoring extraneous `hide'"); ;
    break;}
case 117:
#line 1477 "parser/maria.y"
{;
    break;}
case 118:
#line 1480 "parser/maria.y"
{
	  currentType = (currentPlace = yyvsp[-1].place) ? &yyvsp[-1].place->getType () : NULL;
	;
    break;}
case 119:
#line 1484 "parser/maria.y"
{
	  if (!currentPlace || !currentTransition)
	    yyvsp[0].marking->destroy ();
	  else if (yyvsp[0].marking) {
	    if (class Arc* arc =
		currentTransition->getArc (isOutputArc, *currentPlace)) {
	      if (pnwarnings) {
		thePrinter.printRaw ("Warning:extending arc ");
		thePrinter.printRaw (isOutputArc
				     ? "to place "
				     : "from place ");
		thePrinter.printQuoted (currentPlace->getName ());
		thePrinter.finish ();
	      }
	      arc->append (*yyvsp[0].marking);
	    }
	    else if (isOutputArc && currentTransition->getKind ())
	      yyvsp[0].marking->destroy ();
	    else
	      currentTransition->addArc (*new class Arc
					 (isOutputArc, *yyvsp[0].marking, *currentPlace));
	  }
	  currentPlace = NULL, currentType = NULL;
	;
    break;}
case 120:
#line 1511 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 121:
#line 1514 "parser/maria.y"
{ yyval.flag = true; if (yyvsp[-1].flag) pnerror ("ignoring extraneous `place'"); ;
    break;}
case 122:
#line 1517 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("expected `place', got `trans'"); ;
    break;}
case 124:
#line 1524 "parser/maria.y"
{ pnerror ("ignoring extraneous `place'"); ;
    break;}
case 125:
#line 1527 "parser/maria.y"
{ pnerror ("ignoring extraneous `trans'"); ;
    break;}
case 126:
#line 1531 "parser/maria.y"
{ yyval.flag = false; ;
    break;}
case 127:
#line 1534 "parser/maria.y"
{ yyval.flag = true; if (yyvsp[-1].flag) pnerror ("ignoring extraneous `trans'"); ;
    break;}
case 128:
#line 1537 "parser/maria.y"
{ yyval.flag = yyvsp[-1].flag; pnerror ("expected `trans', got `place'"); ;
    break;}
case 130:
#line 1544 "parser/maria.y"
{ pnerror ("ignoring extraneous `trans'"); ;
    break;}
case 131:
#line 1547 "parser/maria.y"
{ pnerror ("ignoring extraneous `place' after `trans'"); ;
    break;}
case 134:
#line 1558 "parser/maria.y"
{
	  if ((yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr), true)) && currentTransition) {
	    if (yyvsp[0].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<const class Constant*>(yyvsp[0].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      if (bool (static_cast<const class LeafValue&>(v))) {
		pnwarn ("gate is constantly enabled");
		yyvsp[0].expr->destroy ();
	      }
	      else {
		pnwarn ("gate is constantly disabled");
		currentTransition->addGate (*yyvsp[0].expr);
	      }
	    }
	    else if (yyvsp[0].expr->getKind () == Expression::eUndefined) {
	      if (currentTransition->getKind ())
		pnwarn ("multiple 'fatal' or 'undefined' gates");
	      currentTransition->setAssertion
		(static_cast<class Undefined*>(yyvsp[0].expr)->isFatal ());
	      yyvsp[0].expr->destroy ();
	    }
	    else
	      currentTransition->addGate (*yyvsp[0].expr);
	  }
	  else
	    yyvsp[0].expr->destroy ();
	;
    break;}
case 135:
#line 1590 "parser/maria.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr, true))) theNet.addReject (*yyvsp[0].expr); ;
    break;}
case 136:
#line 1593 "parser/maria.y"
{ if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr, true))) theNet.addDeadlock (*yyvsp[0].expr); ;
    break;}
case 137:
#line 1598 "parser/maria.y"
{
	  if ((yyvsp[0].expr = ensureBool (yyvsp[0].expr)) && yyvsp[-2].s) {
	    if (!theNet.addProp (yyvsp[-2].s, *yyvsp[0].expr)) {
	      thePrinter.printRaw ("redefinition of state proposition ");
	      thePrinter.printQuoted (yyvsp[-2].s);
	      thePrinter.finish ();
	      pnerrors++;
	      delete[] yyvsp[-2].s;
	      yyvsp[0].expr->destroy ();
	    }
	  }
	  else {
	    delete[] yyvsp[-2].s; yyvsp[0].expr->destroy ();
	  }
	;
    break;}
case 138:
#line 1617 "parser/maria.y"
{ isFairnessStrong = static_cast<enum Net::CKind>(yyvsp[0].i); ;
    break;}
case 140:
#line 1623 "parser/maria.y"
{ yyval.i = 0; ;
    break;}
case 141:
#line 1626 "parser/maria.y"
{ yyval.i = 1; ;
    break;}
case 142:
#line 1629 "parser/maria.y"
{ yyval.i = 2; ;
    break;}
case 143:
#line 1632 "parser/maria.y"
{ yyval.i = yyvsp[-1].i; pnerror ("ignoring extraneous `weakly_fair'"); ;
    break;}
case 144:
#line 1635 "parser/maria.y"
{ yyval.i = yyvsp[-1].i; pnerror ("ignoring extraneous `strongly_fair'"); ;
    break;}
case 145:
#line 1638 "parser/maria.y"
{ yyval.i = yyvsp[-1].i; pnerror ("ignoring extraneous `enabled'"); ;
    break;}
case 148:
#line 1649 "parser/maria.y"
{
	  if (yyvsp[0].expr && !theNet.addConstraint (*yyvsp[0].expr, isFairnessStrong))
	    pnerror ("error in constraint");
	;
    break;}
case 149:
#line 1657 "parser/maria.y"
{ yyval.marking = ensureMarking (yyvsp[0].expr, currentType); ;
    break;}
case 150:
#line 1662 "parser/maria.y"
{ yyval.marking = yyvsp[0].marking; ;
    break;}
case 151:
#line 1665 "parser/maria.y"
{
	  if ((yyval.marking = yyvsp[-2].marking) && yyvsp[0].marking)
	    yyval.marking->append (*yyvsp[0].marking);
	  else if (yyvsp[0].marking)
	    yyval.marking = yyvsp[0].marking;
	;
    break;}
case 152:
#line 1675 "parser/maria.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 153:
#line 1678 "parser/maria.y"
{ yyvsp[-1].expr = ensureMarking (yyvsp[-1].expr, currentType); ;
    break;}
case 154:
#line 1680 "parser/maria.y"
{
	  assert (!yyvsp[-3].expr || yyvsp[-3].expr->getKind () == Expression::eMarking);
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[0].marking)
	    static_cast<class Marking*>(yyval.expr)->append (*yyvsp[0].marking);
	  else if (yyvsp[0].marking)
	    yyval.expr = yyvsp[0].marking;
	;
    break;}
case 155:
#line 1690 "parser/maria.y"
{ yyval.expr = NULL; ;
    break;}
case 156:
#line 1693 "parser/maria.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 157:
#line 1697 "parser/maria.y"
{ yyval.expr = NULL; ;
    break;}
case 158:
#line 1700 "parser/maria.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 159:
#line 1703 "parser/maria.y"
{ yyval.expr = namedComponent (yyvsp[-1].s, NULL); ;
    break;}
case 160:
#line 1706 "parser/maria.y"
{ yyval.expr = namedComponent (yyvsp[-2].s, yyvsp[0].expr); ;
    break;}
case 161:
#line 1711 "parser/maria.y"
{
	  if (currentContextType && !YYRECOVERING ()) {
	    assert (!currentComponent);

	    switch (currentContextType->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(currentContextType);
		class VectorExpression* v = new class VectorExpression (*type);

		if (!yyvsp[0].expr) {
		  pnerror ("missing expression for first vector component");
		  v->destroy (), yyval.expr = NULL;
		}
		else if (isCompatible (yyvsp[0].expr, currentType))
		  yyval.expr = v, v->setComponent (currentComponent, *yyvsp[0].expr);
		else
		  v->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	      }
	      break;
	    case Type::tBuffer:
	      {
		const class BufferType* type =
		  static_cast<const class BufferType*>(currentContextType);
		class BufferExpression* b = new class BufferExpression (*type);

		if (!yyvsp[0].expr)
		  yyval.expr = b;
		else if (isCompatible (yyvsp[0].expr, currentType))
		  yyval.expr = b, b->append (*yyvsp[0].expr);
		else
		  b->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	      }
	      break;
	    case Type::tStruct:
	      {
		if (!yyvsp[0].expr &&
		    !static_cast<const class StructType*>(currentContextType)
		    ->getSize ())
		  yyval.expr = (new class Constant (*new class StructValue
					    (*currentContextType)))->cse ();
		else {
		  class StructExpression* s =
		    new class StructExpression (*currentContextType);

		  if (isCompatible (yyvsp[0].expr, *s))
		    yyval.expr = s, s->append (*yyvsp[0].expr), currentType = s->getNextType ();
		  else
		    s->destroy (), yyvsp[0].expr->destroy (),
		      yyval.expr = NULL, currentType = NULL;
		}
	      }
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  currentComponent++;
	;
    break;}
case 162:
#line 1776 "parser/maria.y"
{
	  if ((yyval.expr = yyvsp[-2].expr) && currentContextType && !YYRECOVERING ()) {
	    assert (currentComponent > 0);
	    switch (currentContextType->getKind ()) {
	    case Type::tVector:
	      {
		assert (yyval.expr->getKind () == Expression::eVector);
		class VectorExpression* v =
		  static_cast<class VectorExpression*>(yyval.expr);
		const class VectorType* type =
		  static_cast<const class VectorType*>(currentContextType);

		if (currentComponent < type->getSize ()) {
		  if (!yyvsp[0].expr) {
		    thePrinter.printRaw ("missing array item ");
		    thePrinter.print (currentComponent);
		    thePrinter.finish ();
		    pnerrors++;
		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		  else if (isCompatible (yyvsp[0].expr, currentType))
		    v->setComponent (currentComponent, *yyvsp[0].expr);
		  else
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
		else {
		  thePrinter.printRaw ("too many items for array ");
		  printType (*type);
		  thePrinter.finish ();
		  pnerrors++;
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
	      }
	      break;
	    case Type::tBuffer:
	      {
		assert (yyval.expr->getKind () == Expression::eBuffer);
		class BufferExpression* b =
		  static_cast<class BufferExpression*>(yyval.expr);
		const class BufferType* type =
		  static_cast<const class BufferType*>(currentContextType);

		if (b->hasCapacity ()) {
		  if (!yyvsp[0].expr || !b->getSize ()) {
		    thePrinter.printRaw ("missing buffer item ");
		    thePrinter.print (yyvsp[0].expr ? currentComponent : 0);
		    thePrinter.finish ();
		    pnerrors++;
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		  }
		  else if (isCompatible (yyvsp[0].expr, currentType))
		    b->append (*yyvsp[0].expr);
		  else
		    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
		else {
		  thePrinter.printRaw ("too many items for buffer ");
		  printType (*type);
		  thePrinter.finish ();
		  pnerrors++;
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
		}
	      }
	      break;
	    case Type::tStruct:
	      {
		assert (yyval.expr->getKind () == Expression::eStruct);
		class StructExpression* s =
		  static_cast<class StructExpression*>(yyval.expr);

		if (isCompatible (yyvsp[0].expr, *s))
		  s->append (*yyvsp[0].expr), currentType = s->getNextType ();
		else
		  yyval.expr->destroy (), yyvsp[0].expr->destroy (),
		    yyval.expr = NULL, currentType = NULL;
	      }
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyval.expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  currentComponent++;
	;
    break;}
case 163:
#line 1865 "parser/maria.y"
{ yyval.expr = NULL; pnerror ("missing expression"); ;
    break;}
case 164:
#line 1868 "parser/maria.y"
{ yyval.expr = yyvsp[0].expr; ;
    break;}
case 165:
#line 1873 "parser/maria.y"
{ yyval.expr = ensureExpr (yyvsp[0].expr); ;
    break;}
case 166:
#line 1878 "parser/maria.y"
{ yyval.i = 0; ;
    break;}
case 167:
#line 1881 "parser/maria.y"
{ yyval.i = 1; ;
    break;}
case 168:
#line 1884 "parser/maria.y"
{ yyval.i = 2; ;
    break;}
case 169:
#line 1887 "parser/maria.y"
{ yyval.i = 3; ;
    break;}
case 170:
#line 1892 "parser/maria.y"
{ yyval.expr = NULL; ;
    break;}
case 171:
#line 1895 "parser/maria.y"
{
	  yyval.expr = NULL;
	  if (yyvsp[-1].s) {
	    if (class Function* f = getFunction (yyvsp[-1].s)) {
	      if (!(yyval.expr = fold (f->expand (NULL)))) {
		thePrinter.printRaw ("could not expand nullary function ");
		thePrinter.printQuoted (f->getName ());
		thePrinter.finish ();
		pnerrors++;
	      }
	    }
	    else {
	      thePrinter.printRaw ("there is no nullary function ");
	      thePrinter.printQuoted (yyvsp[-1].s);
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	;
    break;}
case 172:
#line 1916 "parser/maria.y"
{
	  class Function* f = NULL;
	  if (yyvsp[-1].s && !(f = getFunction (yyvsp[-1].s))) {
	    thePrinter.printRaw ("there is no function ");
	    thePrinter.printQuoted (yyvsp[-1].s);
	    thePrinter.finish ();
	    pnerrors++;
	  }
	  delete[] yyvsp[-1].s;
	  functionStack.push (f);
	;
    break;}
case 173:
#line 1928 "parser/maria.y"
{
	  assert (!functionStack.empty ());
	  if (class Function* f = functionStack.top ()) {
	    yyval.expr = NULL;
	    if (yyvsp[-1].exprList && !(yyval.expr = fold (f->expand (yyvsp[-1].exprList)))) {
	      thePrinter.printRaw ("could not expand function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	  else
	    yyval.expr = NULL;
	  yyvsp[-1].exprList->destroy ();
	  functionStack.pop ();
	;
    break;}
case 174:
#line 1946 "parser/maria.y"
{
	  yyval.expr = (new class Constant
		(*new class LeafValue (Net::getBoolType (), true)))->cse ();
	;
    break;}
case 175:
#line 1952 "parser/maria.y"
{
	  yyval.expr = (new class Constant
		(*new class LeafValue (Net::getBoolType (), false)))->cse ();
	;
    break;}
case 176:
#line 1958 "parser/maria.y"
{ yyval.expr = yyvsp[0].place ? (new class PlaceContents (*yyvsp[0].place))->cse () : NULL; ;
    break;}
case 177:
#line 1961 "parser/maria.y"
{ yyval.expr = resolveName (yyvsp[0].s); ;
    break;}
case 178:
#line 1964 "parser/maria.y"
{
	  yyval.expr = (new class Constant
		(*new class LeafValue (Net::getCardType (), yyvsp[0].i)))->cse ();
	;
    break;}
case 179:
#line 1970 "parser/maria.y"
{
	  yyval.expr = (new class Constant
		(*new class LeafValue (Net::getCharType (), yyvsp[0].c)))->cse ();
	;
    break;}
case 180:
#line 1976 "parser/maria.y"
{ yyval.expr = (new class Undefined (Undefined::fError))->cse (); ;
    break;}
case 181:
#line 1979 "parser/maria.y"
{ yyval.expr = (new class Undefined (Undefined::fFatalError))->cse (); ;
    break;}
case 182:
#line 1982 "parser/maria.y"
{
	  structLevels.push (StructLevel
			     (currentContextType, currentComponent));

	  if (!currentType) {
	    pnerror ("cannot determine type of structured expression");
	    currentContextType = NULL, currentComponent = 0;
	  }
	  else {
	    assert (!structLevels.empty () || !currentComponent);
	    currentContextType = currentType;
	    currentComponent = 0;

	    switch (currentType->getKind ()) {
	    case Type::tStruct:
	      currentType =
		static_cast<const class StructType*>(currentContextType)
		->getSize ()
		? &(*static_cast<const class StructType*>(currentContextType))
		[currentComponent]
		: NULL;
	      break;
	    case Type::tVector:
	      currentType =
		&static_cast<const class VectorType*>(currentContextType)
		->getItemType ();

	      if (pnwarnings) {
		const class Type& indexType =
		  static_cast<const class VectorType*>(currentContextType)
		  ->getIndexType ();

		switch (indexType.getKind ()) {
		case Type::tInt:
		case Type::tCard:
		case Type::tBool:
		case Type::tChar:
		case Type::tEnum:
		case Type::tId:
		  if (const class Constraint* constraint =
		      indexType.getConstraint ()) {
		    if (constraint->size () <= 1)
		      break;
		  }
		  else
		    break;
		default:
		  pnwarn ("initializing an array indexed by something else"
			  " than a simple continuous type");
		}
	      }

	      break;
	    case Type::tBuffer:
	      currentType =
		&static_cast<const class BufferType*>(currentContextType)
		->getItemType ();

	      break;
	    default:
	      pnerror ("cannot determine type of structured expression");
	      currentType = currentContextType = NULL;
	    }
	  }
	;
    break;}
case 183:
#line 2049 "parser/maria.y"
{
	  yyval.expr = yyvsp[-1].expr;
	  if (currentContextType) {
	    if (yyval.expr) {
	      switch (yyval.expr->getKind ()) {
	      case Expression::eStruct:
		{
		  class StructExpression* s =
		    static_cast<class StructExpression*>(yyval.expr);
		  if (s->getNextType ()) {
		    thePrinter.printRaw ("structure ");
		    printType (*currentContextType);
		    thePrinter.printRaw (" not fully initialized");
		    thePrinter.finish ();
		    pnerrors++;
		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		}
		break;

	      case Expression::eConstant:
	      case Expression::eBuffer:
		break;

	      case Expression::eVector:
		{
		  card_t diff =
		    static_cast<const class VectorType*>(currentContextType)
		    ->getSize () - currentComponent;

		  if (diff) {
		    thePrinter.print (diff);
		    thePrinter.printRaw (diff == 1
					 ? " element of array "
					 : " elements of array ");
		    printType (*currentContextType);
		    thePrinter.printRaw (" left uninitialized");
		    thePrinter.finish ();
		    pnerrors++;

		    yyval.expr->destroy (), yyval.expr = NULL;
		  }
		}
		break;

	      default:
		assert (false);
	      }
	    }

	    StructLevel p = structLevels.top ();
	    currentType = currentContextType;
	    currentContextType = p.first;
	    currentComponent = p.second;
	  }
	  else
	    currentComponent = 0;

	  structLevels.pop ();

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 184:
#line 2114 "parser/maria.y"
{ pushTypeContext (yyvsp[0].type); ;
    break;}
case 185:
#line 2116 "parser/maria.y"
{
	  if ((yyval.expr = yyvsp[0].expr) && yyval.expr->getKind () == Expression::eMarking &&
	      yyval.expr->getType () == currentType);
	  else if ((yyval.expr = noMarking (yyval.expr)) && currentType) {
	    if (!yyval.expr->getType ()) {
	      pnerror ("expression to cast has no type");
	      yyval.expr->destroy (), yyval.expr = NULL;
	    }
	    else
	      makeCompatible (yyval.expr, *currentType, true);
	  }
	  popTypeContext ();
	;
    break;}
case 186:
#line 2131 "parser/maria.y"
{
	  StructLevel p (currentContextType, currentComponent);
	  structLevels.push (p);
	  currentContextType = currentType;
	  currentType = NULL, currentComponent = 0;

	  if (yyvsp[-1].s && currentContextType &&
	      currentContextType->getKind () == Type::tUnion) {
	    const class UnionType* u =
	      static_cast<const class UnionType*>(currentContextType);

	    if ((currentType = (*u)[yyvsp[-1].s]))
	      currentComponent = u->getIndex (yyvsp[-1].s);
	    else {
	      thePrinter.printRaw ("type ");
	      printType (*u);
	      thePrinter.printRaw (" does not have component ");
	      thePrinter.printQuoted (yyvsp[-1].s);
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }
	  else if (yyvsp[-1].s)
	    pnerror ("cannot assign the component of a non-union type");

	  delete[] yyvsp[-1].s;
	;
    break;}
case 187:
#line 2159 "parser/maria.y"
{
	  if ((yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) && currentType) {
	    const class UnionType* u =
	      static_cast<const class UnionType*>(currentContextType);

	    if (isCompatible (yyvsp[0].expr, currentType))
	      yyval.expr = fold (new class UnionExpression (*u, *yyvsp[0].expr,
						    currentComponent));
	    else {
	      thePrinter.printRaw ("type mismatch for ");
	      printType (*u);
	      thePrinter.printRaw (" component ");
	      thePrinter.printQuoted (u->getComponentName (currentComponent));
	      thePrinter.finish ();
	      pnerrors++;

	      yyvsp[0].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;

	  assert (!structLevels.empty ());
	  StructLevel p = structLevels.top ();
	  currentType = currentContextType;
	  currentContextType = p.first;
	  currentComponent = p.second;
	  structLevels.pop ();

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 188:
#line 2193 "parser/maria.y"
{
	  if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && yyvsp[0].s) {
	    if (yyvsp[-2].expr->getType () && yyvsp[-2].expr->getType ()->getKind () == Type::tUnion) {
	      const class UnionType* u =
		static_cast<const class UnionType*>(yyvsp[-2].expr->getType ());

	      if ((*u)[yyvsp[0].s])
		yyval.expr = fold (new class UnionTypeExpression (*yyvsp[-2].expr,
							  u->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*u);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();
		pnerrors++;

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else {
	      pnerror ("cannot determine the component of a non-union value");
	      yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy (), yyval.expr = NULL;

	  delete[] yyvsp[0].s;

	  if (yyval.expr)
	    yyval.expr = fold (yyval.expr);
	;
    break;}
case 189:
#line 2228 "parser/maria.y"
{ if ((yyval.expr = noMarking (yyvsp[0].expr))) (yyval.expr = yyval.expr->cse ())->setAtomic (true); ;
    break;}
case 190:
#line 2231 "parser/maria.y"
{ beginAny (yyvsp[-1].type, NULL, false); ;
    break;}
case 191:
#line 2233 "parser/maria.y"
{ yyval.expr = endAny (yyvsp[-3].type, NULL, yyvsp[0].expr); ;
    break;}
case 192:
#line 2236 "parser/maria.y"
{ beginAny (yyvsp[-2].type, yyvsp[-1].s, false); ;
    break;}
case 193:
#line 2238 "parser/maria.y"
{ yyval.expr = endAny (yyvsp[-4].type, yyvsp[-3].s, yyvsp[0].expr); ;
    break;}
case 194:
#line 2241 "parser/maria.y"
{ yyval.expr = newRelopExpression (false, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 195:
#line 2244 "parser/maria.y"
{ yyval.expr = newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 196:
#line 2247 "parser/maria.y"
{ yyval.expr = newRelopExpression (false, yyvsp[0].expr, yyvsp[-2].expr); ;
    break;}
case 197:
#line 2250 "parser/maria.y"
{ yyval.expr = newNotExpression (newRelopExpression (false, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 198:
#line 2253 "parser/maria.y"
{ yyval.expr = newNotExpression (newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 199:
#line 2256 "parser/maria.y"
{ yyval.expr = newNotExpression (newRelopExpression (false, yyvsp[0].expr, yyvsp[-2].expr)); ;
    break;}
case 200:
#line 2259 "parser/maria.y"
{
	  if (yyvsp[-2].expr && yyvsp[-2].expr->getType () &&
	      yyvsp[-2].expr->getType ()->getKind () == Type::tBuffer) {
	    const class BufferType* type =
	      static_cast<const class BufferType*>(yyvsp[-2].expr->getType ());
	    if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && (yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) &&
		isCompatible (yyvsp[0].expr, &type->getItemType ())) {
	      if (yyvsp[-2].expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyvsp[-2].expr);
		yyval.expr = fold (new class BufferWrite (b->getBuffer (), *yyvsp[0].expr,
						  &b->getIndex ()));
		b->destroy ();
	      }
	      else
		yyval.expr = fold (new class BufferWrite (*yyvsp[-2].expr, *yyvsp[0].expr, NULL));
	    }
	    else
	      yyvsp[-2].expr->destroy (), yyvsp[0].expr->destroy (), yyval.expr = NULL;
	  }
	  else
	    yyval.expr = newBinopExpression (BinopExpression::bPlus, yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 201:
#line 2283 "parser/maria.y"
{
	  if ((yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr)) && yyvsp[-2].expr->getType () &&
	      yyvsp[-2].expr->getType ()->getKind () == Type::tBuffer) {
	    if ((yyval.expr = ensureBuffer (yyvsp[-2].expr))) {
	      class Expression* i = 0;
	      if (yyval.expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyval.expr);
		yyval.expr = &b->getBuffer ();
		i = &b->getIndex ();
		b->destroy ();
	      }
	      yyval.expr = fold (new class BufferRemove (*yyval.expr, ensureCard (yyvsp[0].expr), i));
	    }
	  }
	  else
	    yyval.expr = newBinopExpression (BinopExpression::bMinus, yyvsp[-2].expr, yyvsp[0].expr);
	;
    break;}
case 202:
#line 2302 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bDiv, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 203:
#line 2305 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bMul, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 204:
#line 2308 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bMod, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 205:
#line 2311 "parser/maria.y"
{
	  if ((yyval.expr = ensureIntCard (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uNot, *yyval.expr));
	;
    break;}
case 206:
#line 2317 "parser/maria.y"
{
	  if (yyvsp[0].type) {
	    card_t num = yyvsp[0].type->getNumValues ();
	    assert (num > 0);
	    if (num == CARD_T_MAX) {
	      pnerror ("type has too many values to count");
	      yyval.expr = NULL;
	    }
	    else
	      yyval.expr = (new class Constant (*new class LeafValue
					(Net::getCardType (), num)))->cse ();
	  }
	  else
	    yyval.expr = NULL;
	;
    break;}
case 207:
#line 2334 "parser/maria.y"
{
	  if (yyvsp[0].type && isOrdered (*yyvsp[0].type))
	    yyval.expr = (new class Constant (yyvsp[0].type->getFirstValue ()))->cse ();
	  else
	    yyval.expr = NULL;
	;
    break;}
case 208:
#line 2342 "parser/maria.y"
{
	  if (yyvsp[0].type && isOrdered (*yyvsp[0].type))
	    yyval.expr = (new class Constant (yyvsp[0].type->getLastValue ()))->cse ();
	  else
	    yyval.expr = NULL;
	;
    break;}
case 209:
#line 2350 "parser/maria.y"
{
	  if ((yyval.expr = ensureOrdered (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uPred, *yyval.expr));
	;
    break;}
case 210:
#line 2356 "parser/maria.y"
{
	  if ((yyval.expr = ensureOrdered (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uSucc, *yyval.expr));
	;
    break;}
case 211:
#line 2362 "parser/maria.y"
{
	  if ((yyvsp[0].expr = ensureExpr (yyvsp[0].expr)) && yyvsp[0].expr->getType () &&
	      yyvsp[0].expr->getType ()->getKind () == Type::tBuffer) {
	    if ((yyval.expr = ensureBuffer (yyvsp[0].expr))) {
	      class Expression* i = 0;
	      if (yyval.expr->getKind () == Expression::eBufferIndex) {
		class BufferIndex* b = static_cast<class BufferIndex*>(yyval.expr);
		yyval.expr = &b->getBuffer ();
		i = &b->getIndex ();
		b->destroy ();
	      }
	      yyval.expr = fold (new class BufferRemove (*yyval.expr, 0, i));
	    }
	  }
	  else if ((yyval.expr = ensureIntCard (yyvsp[0].expr)))
	    yyval.expr = fold (new class UnopExpression (UnopExpression::uNeg, *yyval.expr));
	;
    break;}
case 212:
#line 2381 "parser/maria.y"
{ yyval.expr = newBufferUnop (BufferUnop::bPeek, yyvsp[0].expr); ;
    break;}
case 213:
#line 2384 "parser/maria.y"
{ yyval.expr = newBufferUnop (BufferUnop::bUsed, yyvsp[0].expr); ;
    break;}
case 214:
#line 2387 "parser/maria.y"
{ yyval.expr = newBufferUnop (BufferUnop::bFree, yyvsp[0].expr); ;
    break;}
case 215:
#line 2390 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bRol, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 216:
#line 2393 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bRor, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 217:
#line 2396 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bAnd, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 218:
#line 2399 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bXor, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 219:
#line 2402 "parser/maria.y"
{ yyval.expr = newBinopExpression (BinopExpression::bOr, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 220:
#line 2405 "parser/maria.y"
{
	  yyvsp[-2].expr = noMarking (yyvsp[-2].expr);
	  if (yyvsp[-2].expr && yyvsp[0].exprList) {
	    if (!yyvsp[-2].expr->getType ()) {
	      pnerror ("left-hand-side of ? has no type");
	      yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	    }
	    else if (yyvsp[-2].expr->getType ()->getNumValues () != yyvsp[0].exprList->size ()) {
	      thePrinter.printRaw ("left-hand-side of ? has ");
	      thePrinter.print (yyvsp[-2].expr->getType ()->getNumValues ());
	      thePrinter.printRaw ("!=");
	      thePrinter.print (yyvsp[0].exprList->size ());
	      thePrinter.printRaw (" possible values");
	      thePrinter.finish ();
	      pnerrors++;
	      yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	    }
	    else if (yyvsp[-2].expr->getType ()->getNumValues () == 1) {
	      pnwarn ("left-hand-side of ? has only one possible value");
	      yyval.expr = (*yyvsp[0].exprList)[0].copy (); yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy ();
	    }
	    else
	      yyval.expr = fold (new class IfThenElse (*yyvsp[-2].expr, *yyvsp[0].exprList));
	  }
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].exprList->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 221:
#line 2435 "parser/maria.y"
{
	  if ((yyvsp[-3].expr = ensureExpr (yyvsp[-3].expr))) {
	    if (!yyvsp[-3].expr->getType () ||
		yyvsp[-3].expr->getType ()->getKind () != Type::tVector) {
	      pnerror ("left-hand-side of .{[index]expr} is not an array");
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	    else
	      pushTypeContext (&static_cast<const class VectorType*>
			       (yyvsp[-3].expr->getType ())->getIndexType ());
	  }
	;
    break;}
case 222:
#line 2448 "parser/maria.y"
{
	  if (yyvsp[-6].expr)
	    currentType = &static_cast<const class VectorType*>(yyvsp[-6].expr->getType ())
	      ->getItemType ();
	;
    break;}
case 223:
#line 2454 "parser/maria.y"
{
	  if (yyvsp[-9].expr) {
	    currentType = yyvsp[-9].expr->getType ();
	    const class VectorType& type =
	      *static_cast<const class VectorType*>(currentType);

	    if (makeCompatible (yyvsp[-4].expr, type.getIndexType ()) &&
		makeCompatible (yyvsp[-1].expr, type.getItemType ()))
	      yyval.expr = fold (new class VectorAssign (*yyvsp[-9].expr, *yyvsp[-4].expr, *yyvsp[-1].expr));
	    else
	      yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy (), yyvsp[-9].expr->destroy (), yyval.expr = NULL;
	    popTypeContext ();
	  }
	  else
	    yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy (), yyval.expr = NULL;
	;
    break;}
case 224:
#line 2472 "parser/maria.y"
{
	  if ((yyvsp[-3].expr = ensureExpr (yyvsp[-3].expr)) && yyvsp[0].s) {
	    if (!yyvsp[-3].expr->getType () ||
		yyvsp[-3].expr->getType ()->getKind () != Type::tStruct) {
	      pnerror ("left-hand-side of .{comp expr} is not a struct");
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	    const class StructType& type =
	      *static_cast<const class StructType*>(yyvsp[-3].expr->getType ());
	    if (const class Type* ct = type[yyvsp[0].s])
	      pushTypeContext (ct);
	    else {
	      thePrinter.printRaw ("type ");
	      printType (type);
	      thePrinter.printRaw (" does not have component ");
	      thePrinter.printQuoted (yyvsp[0].s);
	      thePrinter.finish ();
	      pnerrors++;
	      yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	    }
	  }
	  else
	    yyvsp[-3].expr->destroy (), yyvsp[-3].expr = NULL;
	;
    break;}
case 225:
#line 2497 "parser/maria.y"
{
	  if (yyvsp[-6].expr) {
	    const class StructType& type =
	      *static_cast<const class StructType*>(yyvsp[-6].expr->getType ());
	    currentType = type[yyvsp[-3].s];
	    if (makeCompatible (yyvsp[-1].expr, *currentType))
	      yyval.expr =
		fold (new class StructAssign (*yyvsp[-6].expr, type.getIndex (yyvsp[-3].s), *yyvsp[-1].expr));
	    else
	      yyvsp[-1].expr->destroy (), yyvsp[-6].expr->destroy (), yyval.expr = NULL;
	    popTypeContext ();
	  }
	  else
	    yyvsp[-1].expr->destroy (), yyval.expr = NULL;
	  delete[] yyvsp[-3].s;
	;
    break;}
case 226:
#line 2515 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureExpr (yyvsp[-2].expr);
	  if (yyvsp[-2].expr && yyvsp[0].s) {
	    if (yyvsp[-2].expr->getType () &&
		yyvsp[-2].expr->getType ()->getKind () == Type::tStruct) {
	      const class StructType *s =
		static_cast<const class StructType*>(yyvsp[-2].expr->getType ());
	      if ((*s)[yyvsp[0].s])
		yyval.expr = fold (new class StructComponent (*yyvsp[-2].expr, s->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*s);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();
		pnerrors++;

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else if (yyvsp[-2].expr->getType () &&
		     yyvsp[-2].expr->getType ()->getKind () == Type::tUnion) {
	      const class UnionType *u =
		static_cast<const class UnionType*>(yyvsp[-2].expr->getType ());
	      if ((*u)[yyvsp[0].s])
		yyval.expr = fold (new class UnionComponent (*yyvsp[-2].expr, u->getIndex (yyvsp[0].s)));
	      else {
		thePrinter.printRaw ("type ");
		printType (*u);
		thePrinter.printRaw (" does not have component ");
		thePrinter.printQuoted (yyvsp[0].s);
		thePrinter.finish ();
		pnerrors++;

		yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	      }
	    }
	    else {
	      pnerror ("only unions and structs have components");
	      yyvsp[-2].expr->destroy (), yyval.expr = NULL;
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy (), yyval.expr = NULL;

	  delete[] yyvsp[0].s;
	;
    break;}
case 227:
#line 2564 "parser/maria.y"
{
	  if ((yyvsp[-1].expr = ensureExpr (yyvsp[-1].expr)) && yyvsp[-1].expr->getType ()) {
	    switch (yyvsp[-1].expr->getType ()->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(yyvsp[-1].expr->getType ());
		pushTypeContext (&type->getIndexType ());
	      }
	      break;
	    case Type::tBuffer:
	      if (yyvsp[-1].expr->getKind () == Expression::eBufferIndex)
		pnerror ("a buffer index has already been specified");
	      break;
	    default:
	      pnerror ("only vector-typed expressions can be indexed");
	      yyvsp[-1].expr->destroy (), yyvsp[-1].expr = NULL;
	    }
	  }
	  else if (yyvsp[-1].expr) {
	    pnerror ("no type for indexed expression");
	    yyvsp[-1].expr->destroy (), yyvsp[-1].expr = NULL;
	  }
	;
    break;}
case 228:
#line 2589 "parser/maria.y"
{
	  if (yyvsp[-4].expr) {
	    switch (yyvsp[-4].expr->getType ()->getKind ()) {
	    case Type::tVector:
	      {
		const class VectorType* type =
		  static_cast<const class VectorType*>(yyvsp[-4].expr->getType ());
		popTypeContext ();

		if (isCompatible (yyvsp[-1].expr, &type->getIndexType ()))
		  yyval.expr = fold (new class VectorIndex (*yyvsp[-4].expr, *yyvsp[-1].expr));
		else
		  yyval.expr = NULL, yyvsp[-4].expr->destroy (), yyvsp[-1].expr->destroy ();
	      }
	      break;
	    case Type::tBuffer:
	      if (yyvsp[-4].expr->getKind () == Expression::eBufferIndex)
		yyvsp[-1].expr->destroy (), yyval.expr = yyvsp[-4].expr;
	      else
		yyval.expr = yyvsp[-1].expr ? (new class BufferIndex (*yyvsp[-4].expr, *yyvsp[-1].expr))->cse () : yyvsp[-4].expr;
	      break;
	    default:
	      assert (false);
	    }
	  }
	  else
	    yyval.expr = NULL, yyvsp[-1].expr->destroy ();
	;
    break;}
case 229:
#line 2619 "parser/maria.y"
{ yyval.expr = newNotExpression (yyvsp[0].expr); ;
    break;}
case 230:
#line 2622 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (true, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 231:
#line 2632 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 232:
#line 2642 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr, true);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, newNotExpression (yyvsp[-2].expr), yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 233:
#line 2652 "parser/maria.y"
{
	  yyval.expr = newNotExpression
	    (newRelopExpression (true, ensureBool (yyvsp[-2].expr), ensureBool (yyvsp[0].expr)));
	;
    break;}
case 234:
#line 2658 "parser/maria.y"
{ yyval.expr = newRelopExpression (true, ensureBool (yyvsp[-2].expr), ensureBool (yyvsp[0].expr)); ;
    break;}
case 235:
#line 2661 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? (new class TemporalUnop (TemporalUnop::Finally, *yyvsp[0].expr))->cse ()
	    : NULL;
	;
    break;}
case 236:
#line 2669 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? (new class TemporalUnop (TemporalUnop::Globally, *yyvsp[0].expr))->cse ()
	    : NULL;
	;
    break;}
case 237:
#line 2677 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  yyval.expr = yyvsp[0].expr
	    ? (new class TemporalUnop (TemporalUnop::Next, *yyvsp[0].expr))->cse ()
	    : NULL;
	;
    break;}
case 238:
#line 2685 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = (new class TemporalBinop
		  (TemporalBinop::Until, *yyvsp[-2].expr, *yyvsp[0].expr))->cse ();
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 239:
#line 2696 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureBool (yyvsp[-2].expr); yyvsp[0].expr = ensureBool (yyvsp[0].expr);
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = (new class TemporalBinop
		  (TemporalBinop::Release, *yyvsp[-2].expr, *yyvsp[0].expr))->cse ();
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 240:
#line 2707 "parser/maria.y"
{ yyval.expr = (new class EmptySet)->cse (); ;
    break;}
case 241:
#line 2710 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sSubset, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 242:
#line 2713 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sIntersection, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 243:
#line 2716 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sMinus, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 244:
#line 2719 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sUnion, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 245:
#line 2722 "parser/maria.y"
{ yyval.expr = newSetExpression (SetExpression::sEquals, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
case 246:
#line 2725 "parser/maria.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cCard, yyvsp[0].expr); ;
    break;}
case 247:
#line 2728 "parser/maria.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cMin, yyvsp[0].expr); ;
    break;}
case 248:
#line 2731 "parser/maria.y"
{ yyval.expr = newCardinalityExpression (CardinalityExpression::cMax, yyvsp[0].expr); ;
    break;}
case 249:
#line 2734 "parser/maria.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 250:
#line 2737 "parser/maria.y"
{
	  yyvsp[-2].expr = ensureCard (yyvsp[-2].expr);
	  class Marking* m = ensureMarking (yyvsp[0].expr, currentType);

	  if ((yyval.expr = m) && yyvsp[-2].expr) {
	    if (yyvsp[-2].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<class Constant*>(yyvsp[-2].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      card_t mult = card_t (static_cast<const class LeafValue&>(v));
	      if (!mult) {
		pnerror ("zero multiplicity");
		yyvsp[-2].expr->destroy (), m->destroy ();
		yyval.expr = m = NULL;
	      }
	      else if (mult == 1)
		yyvsp[-2].expr->destroy ();
	      else {
		for (;;) {
		  if (class Expression* c = m->getMultiplicity ()) {
		    class Expression* card =
		      fold (new class BinopExpression (BinopExpression::bMul,
						       *yyvsp[-2].expr, *c));
		    m->setMultiplicity (card);
		  }
		  else
		    m->setMultiplicity (yyvsp[-2].expr);

		  if ((m = const_cast<class Marking*>(m->getNext ())))
		    yyvsp[-2].expr = (new class Constant
			  (*new class LeafValue
			   (*yyvsp[-2].expr->getType (), mult)))->cse ();
		  else
		    break;
		}
	      }
	    }
	    else {
	      if (m->getNext ())
		yyval.expr = m = static_cast<class Marking*>
		  ((new class Marking (m->getPlace (), m))->cse ());

	      class Expression* card = yyvsp[-2].expr;

	      if (class Expression* c = m->getMultiplicity ())
		card = fold
		  (new class BinopExpression (BinopExpression::bMul, *yyvsp[-2].expr, *c));
	      m->setMultiplicity (card);
	    }
	  }
	  else
	    yyvsp[-2].expr->destroy ();
	;
    break;}
case 251:
#line 2792 "parser/maria.y"
{ beginQuantifier (yyvsp[0].s, yyvsp[-1].type); ;
    break;}
case 252:
#line 2794 "parser/maria.y"
{ continueQuantifier (ASSERT1 (yyvsp[-3].type)); ;
    break;}
case 253:
#line 2796 "parser/maria.y"
{ yyval.expr = endQuantifier (yyvsp[-5].s, yyvsp[-6].type, yyvsp[-3].expr, yyvsp[-1].i, yyvsp[0].expr, false); ;
    break;}
case 254:
#line 2799 "parser/maria.y"
{ yyval.expr = quantifierVariable (yyvsp[-1].s, yyvsp[0].s, false); ;
    break;}
case 255:
#line 2802 "parser/maria.y"
{ yyval.expr = quantifierVariable (yyvsp[-1].s, yyvsp[0].s, true); ;
    break;}
case 256:
#line 2805 "parser/maria.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    pnwarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-3].s && yyvsp[-1].expr->getType ()) {
	    checkIterator (yyvsp[-3].s);
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  }
	  else
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	;
    break;}
case 257:
#line 2819 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr));
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[0].expr && yyvsp[-5].s) {
	    yyvsp[0].expr = yyvsp[0].expr->cse ();
	    if (pnwarnings) {
	      class VariableSet vars;
	      vars.insert (*currentVariables.top ());
	      if (!yyvsp[0].expr->depends (vars, false)) {
		thePrinter.printRaw ("Warning:subset is independent of ");
		thePrinter.printQuoted (currentVariables.top ()->getName ());
		thePrinter.finish ();
	      }
	    }
	    if (yyvsp[0].expr->getKind () == Expression::eConstant) {
	      const class Value& v =
		static_cast<class Constant*>(yyvsp[0].expr)->getValue ();
	      assert (v.getKind () == Value::vLeaf);
	      bool result = bool (static_cast<const class LeafValue&>(v));
	      yyvsp[0].expr->destroy ();
	      pnwarn (result
		      ? "subset criterion always passes"
		      : "subset criterion always fails");
	      if (!result)
		yyval.expr->destroy (), yyval.expr = (new class EmptySet)->cse ();
	    }
	    else
	      yyval.expr = (new class Submarking
		    (*currentVariables.top (), *yyvsp[-3].expr, *yyvsp[0].expr))->cse ();
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  if (yyvsp[-5].s)
	    currentVariables.pop ();
	;
    break;}
case 258:
#line 2855 "parser/maria.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    pnwarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-3].s && yyvsp[-1].expr->getType ()) {
	    checkIterator (yyvsp[-3].s);
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  }
	  else
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	;
    break;}
case 259:
#line 2869 "parser/maria.y"
{
	  yyvsp[0].expr = ensureExpr (yyvsp[0].expr);
	  if ((yyval.expr = yyvsp[-3].expr) && yyvsp[-5].s && yyvsp[0].expr) {
	    yyvsp[0].expr = yyvsp[0].expr->cse ();
	    if (pnwarnings) {
	      class VariableSet vars;
	      vars.insert (*currentVariables.top ());
	      if (!yyvsp[0].expr->depends (vars, false)) {
		thePrinter.printRaw ("Warning:mapping is independent of ");
		thePrinter.printQuoted (currentVariables.top ()->getName ());
		thePrinter.finish ();
	      }
	    }
	    yyval.expr = (new class Mapping
		  (*currentVariables.top (), NULL, *yyvsp[-3].expr, *yyvsp[0].expr))->cse ();
	  }
	  else
	    yyvsp[0].expr->destroy ();
	  if (yyvsp[-5].s)
	    currentVariables.pop ();
	;
    break;}
case 260:
#line 2892 "parser/maria.y"
{
	  if (yyvsp[-1].expr && yyvsp[-1].expr->getKind () == Expression::eEmptySet) {
	    pnwarn ("any subset of an empty set is an empty set");
	    delete[] yyvsp[-5].s, yyvsp[-5].s = NULL;
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	  else if ((yyvsp[-1].expr = ensureSet (yyvsp[-1].expr)) && yyvsp[-5].s && yyvsp[-3].s && yyvsp[-1].expr->getType ()) {
	    checkIterator (yyvsp[-5].s); checkIterator (yyvsp[-3].s);
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-5].s, Net::getCardType (), false));
	    currentVariables.push (new class VariableDefinition
				   (yyvsp[-3].s, *yyvsp[-1].expr->getType (), false));
	  }
	  else {
	    delete[] yyvsp[-5].s, yyvsp[-5].s = NULL;
	    delete[] yyvsp[-3].s, yyvsp[-3].s = NULL;
	  }
	;
    break;}
case 261:
#line 2911 "parser/maria.y"
{
	  yyvsp[0].expr = yyvsp[0].expr ? ensureMarking (yyvsp[0].expr, yyvsp[0].expr->getType ()) : 0;
	  yyval.expr = yyvsp[-3].expr;
	  if (yyvsp[-7].s && yyvsp[-5].s) {
	    class VariableDefinition* token = currentVariables.top ();
	    currentVariables.pop ();
	    class VariableDefinition* mult = currentVariables.top ();
	    currentVariables.pop ();
	    if (yyval.expr && yyvsp[0].expr) {
	      yyvsp[0].expr = yyvsp[0].expr->cse ();
	      if (pnwarnings) {
		class VariableSet vars;
		vars.insert (*token);
		vars.insert (*mult);
		if (!yyvsp[0].expr->depends (vars, false)) {
		  thePrinter.printRaw ("Warning:mapping depends neither on ");
		  thePrinter.printQuoted (token->getName ());
		  thePrinter.printRaw (" nor ");
		  thePrinter.printQuoted (mult->getName ());
		  thePrinter.finish ();
		}
	      }
	      yyval.expr = (new class Mapping
		    (*token, mult, *yyvsp[-3].expr, *yyvsp[0].expr))->cse ();
	    }
	    else
	      yyvsp[0].expr->destroy ();
	  }
	  else
	    yyvsp[0].expr->destroy ();
	;
    break;}
case 262:
#line 2945 "parser/maria.y"
{
	  if (class Function* f = functionStack.top ()) {
	    if (!f->getArity ())
	      yyval.exprList = new class ExpressionList;
	    else {
	      thePrinter.printRaw ("function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.printRaw (" expects ");
	      thePrinter.print (f->getArity ());
	      thePrinter.printRaw (", not zero arguments");
	      thePrinter.finish ();
	      pnerrors++;
	      yyval.exprList = NULL;
	    }
	  }
	  else
	    yyval.exprList = NULL;
	;
    break;}
case 263:
#line 2964 "parser/maria.y"
{
	  const class Type* type = NULL;

	  if (class Function* f = functionStack.top ()) {
	    if (f->getArity ())
	      type = &(*f)[0].getType ();
	    else {
	      thePrinter.printRaw ("function ");
	      thePrinter.printQuoted (f->getName ());
	      thePrinter.printRaw (" takes no arguments");
	      thePrinter.finish ();
	      pnerrors++;
	    }
	  }

	  pushTypeContext (type);
	;
    break;}
case 264:
#line 2982 "parser/maria.y"
{
	  if (currentType &&
	      isCompatible ((yyvsp[0].expr = noMarking (yyvsp[0].expr)), currentType)) {
	    if (functionStack.top ())
	      (yyval.exprList = new class ExpressionList)->append (*yyvsp[0].expr);
	    else {
	      yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	  }
	  else {
	    yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	  popTypeContext ();
	;
    break;}
case 265:
#line 2998 "parser/maria.y"
{
	  const class Type* type = NULL;

	  if (class Function* f = functionStack.top ()) {
	    if (yyvsp[-1].exprList) {
	      if (f->getArity () > yyvsp[-1].exprList->size ())
		type = &(*f)[yyvsp[-1].exprList->size ()].getType ();
	      else {
		thePrinter.printRaw ("function ");
		thePrinter.printQuoted (f->getName ());
		thePrinter.printRaw (" takes only ");
		thePrinter.print (f->getArity ());
		thePrinter.printRaw (" arguments");
		thePrinter.finish ();
		pnerrors++;
	      }
	    }
	  }

	  pushTypeContext (type);
	;
    break;}
case 266:
#line 3020 "parser/maria.y"
{
	  if ((yyval.exprList = yyvsp[-3].exprList) && currentType &&
	      isCompatible ((yyvsp[0].expr = noMarking (yyvsp[0].expr)), currentType)) {
	    if (functionStack.top ())
	      yyval.exprList->append (*yyvsp[0].expr);
	    else {
	      yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	    }
	  }
	  else {
	    yyval.exprList->destroy (); yyvsp[0].expr->destroy (); yyval.exprList = NULL;
	  }
	  popTypeContext ();
	;
    break;}
case 267:
#line 3036 "parser/maria.y"
{ if ((yyval.exprList = yyvsp[-1].exprList)) pnerror ("extraneous comma in argument list"); ;
    break;}
case 268:
#line 3042 "parser/maria.y"
{
	  if (yyvsp[0].expr)
	    (yyval.exprList = new class ExpressionList)->prepend (*yyvsp[0].expr);
	  else
	    yyval.exprList = NULL;
	;
    break;}
case 269:
#line 3050 "parser/maria.y"
{
	  if ((yyval.exprList = yyvsp[-2].exprList) && yyvsp[0].expr) {
	    if (yyval.exprList->getType () && yyvsp[0].expr->getType () &&
		yyval.exprList->getType () != yyvsp[0].expr->getType ()) {
	      pnerror ("incompatible types in ?: expression");
	      yyval.exprList->destroy (), yyvsp[0].expr->destroy (), yyval.exprList = NULL;
	    }
	    else if ((yyvsp[0].expr = yyval.exprList->isSet ()
		      ? ensureMarking (yyvsp[0].expr, yyval.exprList->getType ()
				       ? yyval.exprList->getType ()
				       : yyvsp[0].expr->getType ())
		      : noMarking (yyvsp[0].expr)))
	      yyval.exprList->prepend (*yyvsp[0].expr);
	    else
	      yyval.exprList->destroy (), yyvsp[0].expr->destroy (), yyval.exprList = NULL;
	  }
	  else
	    yyval.exprList->destroy (), yyvsp[0].expr->destroy (), yyval.exprList = NULL;
	;
    break;}
case 270:
#line 3073 "parser/maria.y"
{ beginQuantifier (yyvsp[0].s, yyvsp[-1].type); ;
    break;}
case 271:
#line 3075 "parser/maria.y"
{ continueQuantifier (ASSERT1 (yyvsp[-3].type)); ;
    break;}
case 272:
#line 3077 "parser/maria.y"
{ yyval.expr = endQuantifier (yyvsp[-5].s, yyvsp[-6].type, yyvsp[-3].expr, yyvsp[-1].i, yyvsp[0].expr, true); ;
    break;}
case 273:
#line 3080 "parser/maria.y"
{ currentContextTransition = yyvsp[-1].trans; ;
    break;}
case 274:
#line 3082 "parser/maria.y"
{
	  yyvsp[0].expr = ensureBool (ensureExpr (yyvsp[0].expr));
	  if (yyvsp[-3].trans && yyvsp[0].expr)
	    yyval.expr = (new class TransitionQualifier (*yyvsp[-3].trans, *yyvsp[0].expr->cse ()))->cse ();
	  else
	    yyvsp[0].expr->destroy (), yyval.expr = NULL;
	  currentContextTransition = NULL;
	;
    break;}
case 275:
#line 3092 "parser/maria.y"
{
	  yyval.expr = yyvsp[0].trans
	    ? (new class TransitionQualifier
	       (*yyvsp[0].trans, *(new class Constant
		       (*new class LeafValue
			(Net::getBoolType (), true)))->cse ()))->cse ()
	    : NULL;
	;
    break;}
case 276:
#line 3102 "parser/maria.y"
{ yyval.expr = yyvsp[-1].expr; ;
    break;}
case 277:
#line 3105 "parser/maria.y"
{ yyval.expr = newNotExpression (yyvsp[0].expr); ;
    break;}
case 278:
#line 3108 "parser/maria.y"
{
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (true, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 279:
#line 3117 "parser/maria.y"
{
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, yyvsp[-2].expr, yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 280:
#line 3126 "parser/maria.y"
{
	  if (yyvsp[-2].expr && yyvsp[0].expr)
	    yyval.expr = newBooleanBinop (false, newNotExpression (yyvsp[-2].expr), yyvsp[0].expr);
	  else {
	    yyvsp[-2].expr->destroy (); yyvsp[0].expr->destroy (); yyval.expr = NULL;
	  }
	;
    break;}
case 281:
#line 3135 "parser/maria.y"
{ yyval.expr = newNotExpression (newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr)); ;
    break;}
case 282:
#line 3138 "parser/maria.y"
{ yyval.expr = newRelopExpression (true, yyvsp[-2].expr, yyvsp[0].expr); ;
    break;}
}

#line 705 "/usr/share/bison/bison.simple"


  yyvsp -= yylen;
  yyssp -= yylen;
#if YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;
#if YYLSP_NEEDED
  *++yylsp = yyloc;
#endif

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[YYTRANSLATE (yychar)]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[YYTRANSLATE (yychar)]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* defined (YYERROR_VERBOSE) */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*--------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action |
`--------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;
      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;


/*-------------------------------------------------------------------.
| yyerrdefault -- current state does not do anything special for the |
| error token.                                                       |
`-------------------------------------------------------------------*/
yyerrdefault:
#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */

  /* If its default is to accept any token, ok.  Otherwise pop it.  */
  yyn = yydefact[yystate];
  if (yyn)
    goto yydefault;
#endif


/*---------------------------------------------------------------.
| yyerrpop -- pop the current state because it cannot handle the |
| error token                                                    |
`---------------------------------------------------------------*/
yyerrpop:
  if (yyssp == yyss)
    YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#if YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "Error: state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

/*--------------.
| yyerrhandle.  |
`--------------*/
yyerrhandle:
  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;
#if YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

/*---------------------------------------------.
| yyoverflowab -- parser overflow comes here.  |
`---------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}
#line 3141 "parser/maria.y"


static void
checkIterator (const char* name)
{
  checkName (name, ckIter, "invalid iterator variable name ");
}

static class Type*
copyType (class Type* type)
{
  if (type->getName () || Net::isPredefinedType (*type)) {
    if (!theNet.hasType (*type)) theNet.addType (*type, 0);
    return type->copy ();
  }
  else
    return type;
}

static void
deleteType (class Type* type)
{
  if (type && !type->getName () && !Net::isPredefinedType (*type) &&
      !theNet.hasType (*type))
    delete type;
}

static void
printType (const class Type& type)
{
  if (const char* name = type.getName ())
    thePrinter.print (name);
  else
    type.display (thePrinter);
}

static void pushTypeContext (const class Type* type)
{
  StructLevel p (currentContextType, currentComponent);
  structLevels.push (p);
  StructLevel q (currentType, 0);
  structLevels.push (q);

  currentType = type;
  currentContextType = NULL, currentComponent = 0;
}

static void popTypeContext ()
{
  StructLevel p = structLevels.top ();
  structLevels.pop ();
  currentType = p.first;
  assert (!p.second);
  p = structLevels.top ();
  structLevels.pop ();
  currentContextType = p.first;
  currentComponent = p.second;
}

static const class VariableDefinition*
getParameter (char* name)
{
  for (unsigned i = 0; i < currentArity; i++) {
    if (!strcmp (currentParameters[i]->getName (), name))
      return currentParameters[i];
  }

  return NULL;
}

static void
addParameter (const class Type* type, char* name)
{
  if (!type || !name) {
    delete[] name;
    return;
  }

  if (getParameter (name)) {
    thePrinter.printRaw ("ignoring redefinition of parameter ");
    thePrinter.printQuoted (name);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
    return;
  }

  checkName (name, ckParam, "invalid function parameter name ");

  if (pnwarnings) {
    const char* shadow = 0;
    if (currentTransition && currentTransition->getVariable (name))
      shadow = " shadows a variable";
    else if (getConstant (name) || getConstantFunction (name))
      shadow = " shadows a constant";
    else if (theNet.getType (name))
      shadow = " shadows a type name";

    if (shadow) {
      thePrinter.printRaw ("Warning:parameter ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (shadow);
      thePrinter.finish ();
    }
  }

  class VariableDefinition** v =
    new class VariableDefinition*[currentArity + 1];
  assert (!currentArity || currentParameters);
  assert (currentArity || !currentParameters);

  memcpy (v, currentParameters, currentArity * sizeof *v);
  delete[] currentParameters;
  currentParameters = v;
  currentParameters[currentArity++] =
    new class VariableDefinition (name, *type, false);
}

static class Function*
getFunction (const char* name)
{
  class Function* f = currentTransition
    ? currentTransition->getFunction (name)
    : (currentContextTransition
       ? currentContextTransition->getFunction (name)
       : NULL);
  if (!f)
    f = theNet.getFunction (name);
  return f;
}

static class Function*
getConstantFunction (const char* name)
{
  class Function* f = currentTransition
    ? currentTransition->getFunction (name)
    : (currentContextTransition
       ? currentContextTransition->getFunction (name)
       : NULL);
  if (!f || f->getArity ())
    f = theNet.getFunction (name);
  return f && f->getArity () ? NULL : f;
}

static const class Constant*
getConstant (const char* name)
{
  const class Constant* c = currentTransition
    ? currentTransition->getConstant (name)
    : (currentContextTransition
       ? currentContextTransition->getConstant (name)
       : NULL);
  return c ? c : theNet.getConstant (name);
}

static const class VariableDefinition*
getVariable (char* name)
{
  assert (name != NULL);

  const class VariableDefinition* v = getParameter (name);
  const class Function* f = getConstantFunction (name);
  const class Constant* c = getConstant (name);

  if (v || (v = currentVariables.find (name)))
    goto found;

  if (!currentTransition) {
    if (currentContextTransition &&
	(v = currentContextTransition->getVariable (name)));
    else if (!f && !c &&
	     !(currentType && currentType->getKind () == Type::tEnum &&
	       static_cast<const class EnumType*>(currentType)
	       ->getValue (name))) {
      thePrinter.printRaw ("undefined variable ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      pnerrors++;
    }
    delete[] name;
  }
  else if ((v = currentTransition->getVariable (name))) {
  found:
    delete[] name;
  }
  else if (f || c)
    delete[] name;
  else if (!currentType) {
    thePrinter.printRaw ("cannot determine the type of variable ");
    thePrinter.printQuoted (name);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
  }
  else {
    assert (currentType != NULL);

    if (pnwarnings && theNet.getType (name)) {
      thePrinter.printRaw ("Warning:variable ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a type name");
      thePrinter.finish ();
    }

    if (currentType->getKind () != Type::tEnum ||
	!static_cast<const class EnumType*>(currentType)->getValue (name)) {
      checkName (name, ckVar, "invalid (implicit) variable name ");
      v = &currentTransition->addVariable (name, *currentType, false, false);
    }
    else
      delete[] name;
  }

  return v;
}

static class Expression*
resolveName (char* name)
{
  const class Constant* c = getConstant (name);
  class Function* f = getConstantFunction (name);
  const card_t*const i =
    (currentType && currentType->getKind () == Type::tEnum)
    ? static_cast<const class EnumType*>(currentType)->getValue (name)
    : NULL;
  if (const class VariableDefinition* d = getVariable (name))
    return static_cast<class Variable*>((new class Variable (*d))->cse ());
  else if (c)
    return (const_cast<class Constant*>(c)->copy ())->cse ();
  else if (class Expression* expr = f ? f->expand (NULL) : NULL)
    return fold (expr);
  else if (i)
    return enumValue (*static_cast<const class EnumType*>(currentType), *i);
  else
    return NULL;
}

static class Expression*
ensureSet (class Expression* expr,
	   const class Type* type)
{
  return !expr || expr->isSet () ? expr : ensureMarking (expr, type);
}

static class Marking*
ensureMarking (class Expression* expr,
	       const class Type* type,
	       bool temporal)
{
  if (!expr)
    return NULL;
  else if (expr->getKind () == Expression::eUndefined) {
    pnerror ("undefined marking expressions are not allowed");
    expr->destroy ();
    return NULL;
  }

  assert (expr->getType () || expr->getKind () == Expression::eEmptySet);

  if (expr->getKind () == Expression::eMarking)
    return static_cast<class Marking*>(expr);
  else if (expr->isSet () || expr->isBasic ()) {
    if (currentPlace) {
      if (!type)
	type = &currentPlace->getType ();
      if (!makeCompatible (expr, *type)) {
	pnerror ("marking expression has incompatible type");
	return NULL;
      }
    }

    if (!type || makeCompatible (expr, *type)) {
      class Marking* m = new class Marking (type ? 0 : currentPlace);
      m->setToken (expr);
      return m;
    }
    else
      return NULL;
  }
  else if (temporal) {
    class Marking* m = new class Marking (currentPlace);
    m->setToken (expr);
    return m;
  }
  else {
    pnerror ("marking expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
noMarking (class Expression* expr)
{
  if (expr && expr->getKind () == Expression::eMarking) {
    pnerror ("marking expression not allowed here");
    expr->destroy ();
    return NULL;
  }

  return expr;
}

static class Expression*
ensureExpr (class Expression* expr)
{
  expr = noMarking (expr);

  if (expr && !expr->isBasic ()) {
    pnerror ("basic expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureBool (class Expression* expr, bool undefined)
{
  expr = noMarking (expr);

  if (!expr)
    return NULL;

  if (expr->getKind () == Expression::eUndefined) {
    if (undefined)
      return expr;
    pnerror ("undefined or fatal expression is not meaningful here");
    expr->destroy (); return NULL;
  }

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (expr->getType ()->getKind () != Type::tBool) {
    pnerror ("boolean expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureInt (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tInt:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tCard:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getIntType (), true));
    else if (expr->getType () == &Net::getIntType ())
      return expr;
    /* fall through */
  default:
    pnerror ("signed integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureCard (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tCard:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tInt:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getCardType (), true));
    else if (expr->getType () == &Net::getCardType ())
      return expr;
    /* fall through */
  default:
    pnerror ("unsigned integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureIntCard (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  switch (expr->getType ()->getKind ()) {
  case Type::tCard:
  case Type::tInt:
    return expr;
  case Type::tEnum:
  case Type::tChar:
  case Type::tBool:
    if (!makeCompatible (expr, Net::getCardType (), true));
    else if (expr->getType () == &Net::getCardType () ||
	     expr->getType () == &Net::getIntType ())
      return expr;
    /* fall through */
  default:
    pnerror ("integer expression expected");
    expr->destroy ();
    return NULL;
  }
}

static class Expression*
ensureBuffer (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (expr->getType ()->getKind () != Type::tBuffer) {
    pnerror ("buffer expression expected");
    expr->destroy (); return NULL;
  }

  return expr;
}

static class Expression*
ensureOrdered (class Expression* expr)
{
  expr = ensureExpr (expr);

  if (!expr)
    return NULL;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    expr->destroy (); return NULL;
  }

  if (!isOrdered (*expr->getType ())) {
    expr->destroy (); return NULL;
  }

  return expr;
}

static void
addEnumeration (class EnumType* e, char* name)
{
  assert (e && name);
  const card_t* const i = e->getValue (name);
  if (i) {
    thePrinter.printRaw ("enumeration constant ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" already defined as ");
    thePrinter.print (*i);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
  }
  else
    e->addEnumeration (name);
  if (pnwarnings) {
    if (getConstant (name)) {
      thePrinter.printRaw ("Warning:enumeration constant ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a constant");
      thePrinter.finish ();
    }
    else if (theNet.getType (name)) {
      thePrinter.printRaw ("Warning:enumeration constant ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a type name");
      thePrinter.finish ();
    }
  }
}

static void
addEnumeration (class EnumType* e, char* name, card_t value)
{
  assert (e && name);
  const card_t* const i = e->getValue (name);
  if (e->getValue (name)) {
    thePrinter.printRaw ("enumeration constant ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" already defined as ");
    thePrinter.print (*i);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
  }
  else if (e->hasValue (value)) {
    thePrinter.printRaw ("enumeration already contains the value ");
    thePrinter.print (value);
    thePrinter.finish ();
    pnerrors++;
    delete[] name;
  }
  else
    e->addEnumeration (name, value);
  if (pnwarnings) {
    if (getConstant (name)) {
      thePrinter.printRaw ("Warning:enumeration constant ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a constant");
      thePrinter.finish ();
    }
    else if (theNet.getType (name)) {
      thePrinter.printRaw ("Warning:enumeration constant ");
      thePrinter.printQuoted (name);
      thePrinter.printRaw (" shadows a type name");
      thePrinter.finish ();
    }
  }
}

static class Value*
ensureConstant (class Expression* expr, const class Type* type)
{
  if (!(expr = fold (expr)))
    return NULL;

  if (!type) {
    expr->destroy ();
    return NULL;
  }

  if (!isOrdered (*type)) {
    expr->destroy ();
    return NULL;
  }

  class Value* v = NULL;
  if (expr->getKind () == Expression::eConstant) {
    const class Valuation empty;
    v = expr->eval (empty);
    assert (!!v);
  }
  else
    pnerror ("constant expected");

  expr->destroy ();

  switch (type->getKind ()) {
  case Type::tInt:
  case Type::tCard:
  case Type::tBool:
  case Type::tChar:
  case Type::tEnum:
    break;
  default:
    if (&v->getType () == type)
      return v;
    thePrinter.printRaw ("unable to convert constant from ");
    printType (v->getType ());
    thePrinter.printRaw (" to ");
    printType (*type);
    thePrinter.finish ();
    pnerrors++;
    delete v;
    return NULL;
  }

  /** the integer value */
  struct {
    /** tag: is the value unsigned */
    bool u;
    /** the actual value */
    union {
      int_t i; ///< signed
      card_t u; ///< unsigned
    } v;
  } value;

  switch (v->getType ().getKind ()) {
  case Type::tInt:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = false, value.v.i = int_t (static_cast<class LeafValue&>(*v));
    break;
  case Type::tCard:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = true, value.v.u = card_t (static_cast<class LeafValue&>(*v));
    break;
  case Type::tBool:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = true, value.v.u = bool (static_cast<class LeafValue&>(*v));
    break;
  case Type::tChar:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = false, value.v.i = int_t (static_cast<class LeafValue&>(*v));
    break;
  case Type::tEnum:
    assert (v->getKind () == Value::vLeaf);
    if (&v->getType () == type)
      return v;
    value.u = true, value.v.u = card_t (static_cast<class LeafValue&>(*v));
    break;

  default:
    if (&v->getType () == type)
      return v;
    thePrinter.printRaw ("cannot define constraint: incompatible type ");
    printType (v->getType ());
    thePrinter.finish ();
    pnerrors++;
    delete v;
    return NULL;
  }

  if (pnwarnings && v->getType ().getKind () != type->getKind () &&
      !((type->getKind () == Type::tInt || type->getKind () == Type::tCard) &&
	(v->getType ().getKind () == Type::tInt ||
	 v->getType ().getKind () == Type::tCard))) {
    thePrinter.printRaw ("Warning:converting constant ");
    thePrinter.print (value.u ? value.v.u : value.v.i);
    thePrinter.printRaw (" from ");
    printType (v->getType ());
    thePrinter.printRaw (" to ");
    printType (*type);
    thePrinter.finish ();
  }

  delete v;
  v = NULL;
  switch (type->getKind ()) {
  case Type::tInt:
    if (value.u) {
      if (value.v.u > INT_T_MAX)
	break;
      value.v.i = value.v.u, value.u = false;
    }
    if (type->isConstrained (*(v = new class LeafValue (*type, value.v.i))))
      return v;
    delete v;
    break;
  case Type::tCard:
    if (!value.u) {
      if (value.v.i < 0)
	break;
      value.v.u = value.v.i, value.u = true;
    }
    if (type->isConstrained (*(v = new class LeafValue (*type, value.v.u))))
      return v;
    delete v;
    break;
  case Type::tBool:
    if (value.u) {
      if ((value.v.u == 0 || value.v.u == 1) &&
	  type->isConstrained (*(v = new class LeafValue (*type,
							  value.v.u == 1))))
	return v;
    }
    else {
      if ((value.v.i == 0 || value.v.i == 1) &&
	  type->isConstrained (*(v = new class LeafValue (*type,
							  value.v.i == 1))))
	return v;
    }
    delete v;
    break;
  case Type::tChar:
    if (!value.u) {
      if (value.v.i < 0)
	break;
      value.v.u = value.v.i, value.u = true;
    }
    if (value.v.u <= CHAR_T_MAX &&
	type->isConstrained (*(v = new class LeafValue (*type, value.v.u))))
      return v;
    delete v;
    break;
  case Type::tEnum:
    if (!value.u) {
      if (value.v.i < 0)
	break;
      value.v.u = value.v.i, value.u = true;
    }
    if (type->isConstrained (*(v = new class LeafValue (*type, value.v.u))) ||
	!type->getConstraint ())
      return v;
    delete v;
    break;

  default:
    assert (false);
  }

  thePrinter.printRaw ("value ");
  thePrinter.print (value.u ? value.v.u : value.v.i);
  thePrinter.printRaw (" out of range for type ");
  printType (*type);
  thePrinter.finish ();
  pnerrors++;
  return NULL;
}

static class Expression*
enumValue (const class EnumType& type, card_t value)
{
  class LeafValue* e = new class LeafValue (type, value);
  if (type.isConstrained (*e))
    return (new class Constant (*e))->cse ();
  else {
    thePrinter.printRaw ("enumeration constant ");
    if (const char* c = type.getEnumName (value)) {
      thePrinter.print (c);
      thePrinter.delimiter ('=');
    }
    thePrinter.print (value);
    thePrinter.printRaw (" out of range for type ");
    printType (type);
    thePrinter.finish ();
    pnerrors++;
    delete e;
    return NULL;
  }
}

static class Expression*
namedComponent (char* name, class Expression* expr)
{
  if (!name) {
    expr->destroy ();
    return NULL;
  }

  if (!currentContextType || currentContextType->getKind () != Type::tStruct) {
    thePrinter.printRaw ("named component ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" can only be used with a struct");
    thePrinter.finish ();
    pnerrors++;
    expr->destroy ();
    delete[] name;
    return NULL;
  }

  const class StructType& type =
    static_cast<const class StructType&>(*currentContextType);

  if (currentComponent < type.getSize ()) {
    const char* comp = type.getComponentName (currentComponent);
    if (strcmp (name, comp)) {
      thePrinter.printRaw ("expecting named component ");
      thePrinter.printQuoted (comp);
      thePrinter.printRaw (" instead of ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      pnerrors++;
      expr->destroy ();
      delete[] name;
      return NULL;
    }
  }
  else {
    thePrinter.printRaw ("extraneous named component ");
    thePrinter.printQuoted (name);
    thePrinter.printRaw (" at end of struct");
    thePrinter.finish ();
    pnerrors++;
    expr->destroy ();
    delete[] name;
    return NULL;
  }

  delete[] name;
  return expr;
}

static void
beginAny (class Type*& type, char* name,
	  bool hidden)
{
  if (type) {
    if (currentTransition) {
      if (currentTransition->getKind ()) {
	thePrinter.printRaw ("assertion transitions do not output");
	thePrinter.finish ();
	pnerrors++;
	type = NULL; delete[] name;
      }
      else if (name && currentTransition->getVariable (name)) {
	thePrinter.printRaw ("output variable ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (" shadows another variable");
	thePrinter.finish ();
	pnerrors++;
	type = NULL; delete[] name;
      }
      else {
	if (name) {
	  checkIterator (name);
	  currentTransition->addVariable (name, *type, true, hidden);
	}
	card_t size = type->getNumValues ();
	if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
	  thePrinter.printRaw ("type ");
	  printType (*type);
	  thePrinter.printRaw (" has too many (");
	  thePrinter.print (size);
	  thePrinter.printRaw (") values for non-determinism");
	  if (size && size < CARD_T_MAX)
	    thePrinter.printRaw (" (try -q0)");
	  thePrinter.finish ();
	  pnerrors++;
	}
      }
    }
    else {
      pnerror ("non-determinism is only allowed on output arcs");
      type = NULL; delete[] name;
    }
  }
  else
    delete[] name;

  pushTypeContext (type);
}

static class Variable*
endAny (const class Type* type,
	char* name,
	class Expression* condition)
{
  class Variable* var;
  popTypeContext ();

  if (type) {
    if (!condition || (condition = ensureBool (ensureExpr (condition)))) {
      var = static_cast<class Variable*>
	((new class Variable
	  (currentTransition->addOutputVariable (*type, name,
						 condition)))->cse ());
      assert (var != NULL);
      if (pnwarnings && condition) {
	class VariableSet vars;
	vars.insert (var->getVariable ());
	if (!condition->depends (vars, false)) {
	  thePrinter.printRaw ("Warning:condition is independent of ");
	  thePrinter.printQuoted (var->getVariable ().getName ());
	  thePrinter.finish ();
        }
      }
    }
    else
      var = NULL, condition->destroy ();
  }
  else
    var = NULL, condition->destroy ();
  return var;
}

static void
beginQuantifier (char* name, const class Type* type)
{
  if (name && type) {
    checkIterator (name);
    if (pnwarnings) {
      const char* shadow = 0;
      if (currentVariables.find (name))
        shadow = " shadows another quantifier";
      else if ((currentTransition &&
		currentTransition->getVariable (name)) ||
	       (currentContextTransition &&
		currentContextTransition->getVariable (name)))
	shadow = " shadows a transition variable";
      else if (getConstant (name))
	shadow = " shadows a constant";
      else if (currentType && currentType->getKind () == Type::tEnum &&
	       static_cast<const class EnumType*>(currentType)->
	       getValue (name))
	shadow = " shadows an enumeration constant";
      else if (theNet.getType (name))
	shadow = " shadows a type name";

      if (shadow) {
	thePrinter.printRaw ("quantifier ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (shadow);
	thePrinter.finish ();
      }
    }

    card_t size = type->getNumValues ();
    if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
      thePrinter.printRaw ("type ");
      printType (*type);
      thePrinter.printRaw (" has too many (");
      thePrinter.print (size);
      thePrinter.printRaw (") values for quantification");
      if (size && size < CARD_T_MAX)
	thePrinter.printRaw (" (try -q0)");
      thePrinter.finish ();
      pnerrors++;
    }
    currentVariables.push (new class VariableDefinition (name, *type, true));
  }

  struct TypeContext tc = {
    currentContextType,
    currentType,
    currentComponent
  };
  typeStack.push (tc);

  currentContextType = NULL;
  currentComponent = 0;
  currentType = type;
}

static void
continueQuantifier (ASSERT1 (const class Type* type))
{
  assert (!currentContextType);
  assert (currentType == type);
  assert (!typeStack.empty ());
  struct TypeContext tc = typeStack.top ();
  typeStack.pop ();

  currentContextType = tc.context;
  currentType = tc.component;
  currentComponent = tc.numComponent;
}

static class Expression*
endQuantifier (char* name,
	       const class Type* type,
	       class Expression* condition,
	       unsigned kind,
	       class Expression* expr,
	       bool temporal)
{
  if (name && type && expr && kind) {
    class VariableDefinition* var = currentVariables.top ();
    currentVariables.pop ();

    card_t size = var->getType ().getNumValues ();
    if (!size || size == CARD_T_MAX || (maxRange && size > maxRange)) {
      condition->destroy ();
      expr->destroy ();
      delete var;
      return NULL;
    }

    if ((condition = ensureBool (ensureExpr (condition))) && pnwarnings) {
      class VariableSet vars;
      vars.insert (*var);
      if (!condition->depends (vars, false)) {
	thePrinter.printRaw ("Warning:condition is independent of ");
	thePrinter.printQuoted (var->getName ());
	thePrinter.finish ();
      }
    }

    class Valuation v;
    switch (kind) {
    case 1:
      if (class Marking* m = ensureMarking (expr, currentType, temporal)) {
	expr = m->quantify (v,
			    currentTransition
			    ? currentTransition
			    : currentContextTransition,
			    *var, condition,
			    currentTransition && !temporal);
	m->destroy ();
	condition->destroy ();
	delete var;
	if (!expr) {
	  if (check (v))
	    pnerror ("conflicting variables in quantification");
	}
	else
	  assert (v.isOK ());
	return expr->cse ();
      }
      else
	expr = NULL;
      break;
    case 2:
    case 3:
      if ((expr = ensureBool (expr))) {
	class Expression* e =
	  BooleanBinop::quantify (kind != 2,
				  *expr, v,
				  currentTransition
				  ? currentTransition
				  : currentContextTransition,
				  *var, condition,
				  currentTransition && !temporal);
	expr->destroy ();
	delete var;
	if (!e) {
	  if (check (v))
	    pnerror ("conflicting variables in quantification");
	}
	else
	  assert (v.isOK ());
	return e->cse ();
      }
      break;
    default:
      assert (false);
    }

    expr->destroy ();
    delete var;
    return NULL;
  }
  else {
    condition->destroy (), expr->destroy ();
    if (name && type) {
      class VariableDefinition* var = currentVariables.top ();
      currentVariables.pop ();
      delete var;
    }
    else
      delete[] name;
    return NULL;
  }
}

static class Expression*
quantifierVariable (char* prefix, char* quant, bool p)
{
  char delimiter = p ? ',' : '.';
  if (!prefix) {
    delete[] prefix;
    delete[] quant;
    return NULL;
  }
  class VariableDefinition* var;
  if (currentVariables.empty ())
    var = NULL;
  else if (quant)
    var = currentVariables.find (quant);
  else
    var = currentVariables.top ();

  if (!var) {
    thePrinter.delimiter (delimiter);
    thePrinter.print (prefix);
    if (quant) {
      thePrinter.printRaw (": quantifier ");
      thePrinter.print (quant);
      thePrinter.printRaw (" not found");
    }
    else
      thePrinter.printRaw (": no quantifier found");
    thePrinter.finish ();
    pnerrors++;
  }
  else if (!var->isAggregate ()) {
    thePrinter.delimiter (delimiter);
    thePrinter.print (prefix);
    thePrinter.printRaw (": variable ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (" is not a quantifier");
    thePrinter.finish ();
    pnerrors++;
  }
  else if (!currentTransition && !currentContextTransition) {
    thePrinter.printRaw ("quantifier ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (": cannot define ");
    thePrinter.delimiter (delimiter);
    thePrinter.print (prefix);
    thePrinter.printRaw (" outside transition");
    thePrinter.finish ();
    pnerrors++;
  }
  else if (!currentType) {
    if (const class VariableDefinition* qvar = var->findChild (prefix)) {
      delete[] quant;
      delete[] prefix;
      return (new class Variable (*qvar, p))->cse ();
    }
    else {
      thePrinter.printRaw ("quantifier ");
      thePrinter.print (var->getName ());
      thePrinter.printRaw (": cannot determine the type of ");
      thePrinter.delimiter (delimiter);
      thePrinter.print (prefix);
      thePrinter.finish ();
      pnerrors++;
    }
  }
  else if (const class VariableDefinition* qvar =
	   var->addChild (prefix, *currentType)) {
    delete[] quant;
    return (new class Variable (*qvar, p))->cse ();
  }
  else {
    thePrinter.printRaw ("quantifier ");
    thePrinter.print (var->getName ());
    thePrinter.printRaw (": contradictory type for ");
    thePrinter.delimiter (delimiter);
    thePrinter.print (prefix);
    thePrinter.finish ();
    pnerrors++;
  }

  delete[] prefix;
  delete[] quant;
  return NULL;
}

static bool
makeCompatible (class Expression*& expr,
		const class Type& type,
		bool casting)
{
  if (!expr) return false;
  if (expr->getType () == &type ||
      expr->getKind () == Expression::eEmptySet)
    return true;
  assert (!!expr->getType ());
  const class Type& srcType = *expr->getType ();
  if (((Typecast::isCastable (type) &&
	Typecast::isCastable (srcType)) ||
       Type::isCompatible (srcType, type)) &&
      expr->isBasic () && !expr->isSet ()) {
    bool isConstant = expr->getKind () == Expression::eConstant;
    expr = (new class Typecast (type, *expr))->cse ();
    if (!casting && pnwarnings &&
	((!srcType.isAssignable (type) &&
	  srcType.getKind () != Type::tCard &&
	  srcType.getKind () != Type::tInt &&
	  type.getKind () != Type::tCard &&
	  type.getKind () != Type::tInt) ||
	 (!isConstant && !srcType.isAlwaysAssignable (type)))) {
      thePrinter.printRaw ("Warning:implicit conversion from ");
      printType (srcType);
      thePrinter.printRaw (" to ");
      printType (type);
      thePrinter.finish ();
    }
    if (isConstant && !(expr = fold (expr))) {
      thePrinter.printRaw ("cannot convert constant from ");
      printType (srcType);
      thePrinter.printRaw (" to ");
      printType (type);
      thePrinter.finish ();
      pnerrors++;
      return false;
    }
    return true;
  }
  else {
    thePrinter.printRaw ("cannot convert from ");
    printType (srcType);
    thePrinter.printRaw (" to ");
    printType (type);
    thePrinter.finish ();
    pnerrors++;
    return false;
  }
}

static bool
isCompatible (class Expression*& expr,
	      const class Type* type)
{
  if (!type) {
    pnerror ("too many components for struct");
    return false;
  }

  if (!expr)
    return false;

  if (!expr->getType ()) {
    pnerror ("expression has no type");
    return false;
  }

  return makeCompatible (expr, *type);
}

static bool
isCompatible (class Expression*& expr,
	      const class StructExpression& s)
{
  const class Type* type = s.getNextType ();
  const char* structName = s.getType ()->getName ();

  if (!type) {
    if (structName) {
      thePrinter.printRaw ("too many components for struct ");
      thePrinter.printQuoted (structName);
    }
    else
      thePrinter.printRaw ("too many components for struct");
    thePrinter.finish ();
    pnerrors++;
    return false;
  }

  const char* comp =
    static_cast<const class StructType*>(s.getType ())
    ->getComponentName (s.size ());

  if (!expr) {
    if (structName) {
      thePrinter.printRaw ("error in expression for struct ");
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("error in expression for struct component ");
    thePrinter.printQuoted (comp);
    thePrinter.finish ();
    pnerrors++;
    return false;
  }

  if (!expr->getType ()) {
    if (structName) {
      thePrinter.printRaw ("expression for struct ");
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("expression for struct component ");
    thePrinter.printQuoted (comp);
    thePrinter.printRaw (" has no type");
    thePrinter.finish ();
    pnerrors++;
    return false;
  }

  if (!makeCompatible (expr, *type))
    return false;

  if (!expr->getType ()->isAlwaysAssignable (*type)) {
    if (Type::isCompatible (*expr->getType (), *type))
      thePrinter.printRaw ("too broad type for struct ");
    else
      thePrinter.printRaw ("type mismatch for struct ");
    if (structName) {
      thePrinter.printQuoted (structName);
      thePrinter.printRaw (" component ");
    }
    else
      thePrinter.printRaw ("component ");
    thePrinter.printQuoted (comp);
    thePrinter.finish ();
    pnerrors++;
    return false;
  }
  else if (expr->getType () != type)
    expr = (new class Typecast (*type, *expr))->cse ();

  return true;
}

static bool
isOrdered (const class Type& type)
{
  if (!type.isOrdered ()) {
    thePrinter.printRaw ("unordered type ");
    printType (type);
    thePrinter.finish ();
    pnerrors++;
    return false;
  }

  return true;
}

static bool
check (const class Valuation& v)
{
  bool ok = true;

  switch (v.getError ()) {
  case errDiv0:
    ok = false, pnerror ("division by zero"); break;
  case errOver:
    ok = false, pnerror ("overflow"); break;
  case errMod:
    ok = false, pnerror ("modulus error"); break;
  case errShift:
    ok = false, pnerror ("shift error"); break;
  case errConst:
    ok = false, pnerror ("constraint violation"); break;
  case errUnion:
    ok = false, pnerror ("union violation"); break;
  case errBuf:
    ok = false, pnerror ("buffer violation"); break;
  case errCard:
    ok = false, pnerror ("cardinality overflow"); break;
  case errComp:
    assert (false);
  case errNone:
  case errVar:
  case errUndef:
  case errFatal:
    break;
  }

  return ok;
}

static class Expression*
fold (class Expression* expr)
{
  if (expr && expr->isBasic ()) {
    class Valuation v;
    if (class Value* value = expr->eval (v)) {
      assert (v.isOK ());
      expr->destroy ();
      return (new class Constant (*value))->cse ();
    }
    else {
      if (!check (v)) {
	expr->destroy ();
	return NULL;
      }
      else {
	if (v.getError () == errFatal) {
	  expr->destroy ();
	  return (new class Undefined (Undefined::fFatalError))->cse ();
	}
	if (v.getError () == errUndef) {
	  expr->destroy ();
	  return (new class Undefined (Undefined::fError))->cse ();
	}

	assert (v.getError () == errVar);
	return expr->cse ();
      }
    }
  }
  else
    return expr->cse ();
}

static void
defun (const class Type* type,
       char* name,
       class Expression* expr)
{
  currentType = NULL;
  if (!currentArity && type && !type->isLeaf () && name && expr &&
      expr->getKind () == Expression::eConstant) {
    if (isCompatible (expr, type)) {
      if (currentTransition) {
	if (!currentTransition->addConstant
	    (name, *static_cast<class Constant*>(expr))) {
	redef:
	  thePrinter.printRaw ("ignoring redefinition of constant ");
	  thePrinter.printQuoted (name);
	  thePrinter.finish ();
	  pnerrors++;
	  delete[] name, expr->destroy ();
	}
	else if (pnwarnings && theNet.getConstant (name)) {
	  thePrinter.printRaw ("Warning:definition of constant ");
	  thePrinter.printQuoted (name);
	  thePrinter.printRaw (" shadows the global definition");
	  thePrinter.finish ();
	}
      }
      else if (!theNet.addConstant
	       (name, *static_cast<class Constant*>(expr)))
	goto redef;
    }
  }
  else if (type && name && expr) {
    if ((currentTransition && currentTransition->getFunction (name)) ||
	(!currentTransition && theNet.getFunction (name))) {
      thePrinter.printRaw ("ignoring redefinition of function ");
      thePrinter.printQuoted (name);
      thePrinter.finish ();
      pnerrors++;
      delete[] name, expr->destroy ();
    }
    else if (isCompatible (expr, type)) {
      class Function* f =
	new class Function (name, currentArity, currentParameters, expr);
      if (currentTransition) {
	currentTransition->addFunction (*f);
	if (pnwarnings && theNet.getFunction (name)) {
	  thePrinter.printRaw ("Warning:definition of function ");
	  thePrinter.printQuoted (name);
	  thePrinter.printRaw (" shadows the global definition");
	  thePrinter.finish ();
	}
      }
      else
	theNet.addFunction (*f);

      if (pnwarnings && theNet.getType (name)) {
	thePrinter.printRaw ("Warning:function ");
	thePrinter.printQuoted (name);
	thePrinter.printRaw (" shadows a type name");
	thePrinter.finish ();
	for (unsigned i = 0; i < currentArity; i++) {
	  class VariableSet vars;
	  vars.insert (*currentParameters[i]);
	  if (!expr->depends (vars, false)) {
	    thePrinter.printRaw ("Warning:function ");
	    thePrinter.printQuoted (name);
	    thePrinter.printRaw (" does not use parameter ");
	    thePrinter.printQuoted (currentParameters[i]->getName ());
	    thePrinter.finish ();
	  }
	}
      }
    }
    else
      delete[] name, expr->destroy ();
  }
  else
    delete[] name, expr->destroy ();
  currentArity = 0, currentParameters = 0;
  emptyParsed = false;
}

static class Expression*
newRelopExpression (bool equal,
		    class Expression* left,
		    class Expression* right)
{
  left = ensureExpr (left); right = ensureExpr (right);
  if (!left || !right);
  else if (left->getType () != right->getType ()) {
    if (left->getKind () == Expression::eConstant &&
	makeCompatible (left, *right->getType ()))
      goto ok;
    if (right->getKind () == Expression::eConstant &&
	makeCompatible (right, *left->getType ()))
      goto ok;
    pnerror ("expressions in comparison have different types");
  }
  else if (!left->getType ()->isOrdered () && !equal)
    pnerror ("cannot compare expressions of unordered type");
  else {
  ok:
    return fold (RelopExpression::construct (equal, *left, *right));
  }

  left->destroy ();
  right->destroy ();
  return 0;
}

static class Expression*
newBinopExpression (enum BinopExpression::Op op,
		    class Expression* left,
		    class Expression* right)
{
  if (left && left->getType () &&
      left->getType ()->getKind () == Type::tVector) {
    bool shl = false;
    switch (op) {
    case BinopExpression::bRol:
      shl = true;
      break;
    case BinopExpression::bRor:
      shl = false;
      break;
    default:
      ensureIntCard (left)->destroy ();
      ensureIntCard (right)->destroy ();
      return NULL;
    }
    if ((left = ensureExpr (left)) && (right = ensureCard (right))) {
      size_t size =
	static_cast<const class VectorType*>(left->getType ())->getSize ();

      if (shl ||
	  (right = fold (new class BinopExpression
			  (BinopExpression::bMinus,
			   *new class Constant (*new class LeafValue
						(Net::getCardType (),
						 card_t (size))), *right)))) {
	if (right->getKind () == Expression::eConstant) {
	  const class Value& v =
	    static_cast<class Constant*>(right)->getValue ();
	  assert (v.getKind () == Value::vLeaf);
	  card_t amount = static_cast<const class LeafValue&>(v);
	  if (!(amount %= size)) {
	    right->destroy ();
	    return left;
	  }
	}
	return fold (new class VectorShift (*left, *right));
      }
    }
    left->destroy (), right->destroy ();
    return NULL;
  }

  left = ensureIntCard (left);
  right = ensureIntCard (right);
  if (!left || !right) {
    left->destroy (), right->destroy ();
    return NULL;
  }

  if (!(right = left->getType ()->getKind () == Type::tCard
	? ensureCard (right) : ensureInt (right))) {
    left->destroy ();
    return NULL;
  }

  return fold (new class BinopExpression (op, *left, *right));
}

static class Expression*
newNotExpression (class Expression* expr)
{
  if ((expr = ensureBool (expr)))
    expr = fold (NotExpression::construct (*expr));
  return expr;
}

static class Expression*
newBooleanBinop (bool conj,
		 class Expression* left,
		 class Expression* right)
{
  assert (left && right);
  assert (left->getKind () == Expression::eUndefined ||
	  (left->getType () && left->getType ()->getKind () == Type::tBool));
  assert (right->getKind () == Expression::eUndefined ||
	  (right->getType () && right->getType ()->getKind () == Type::tBool));
  assert (left == left->cse ());
  assert (right == right->cse ());

  return (BooleanBinop::construct (conj, *left, *right))->cse ();
}

static class Expression*
newSetExpression (enum SetExpression::Op op,
		  class Expression* left,
		  class Expression* right)
{
  const class Type* type = 0;
  if (right && right->isSet ())
    type = right->getType ();
  else if (left && left->isSet ())
    type = left->getType ();
  left = ensureSet (left, type);
  right = ensureSet (right, type);
  if (!left || !right) {
    left->destroy (), right->destroy ();
    return NULL;
  }

  if (left->getKind () == Expression::eEmptySet) {
    if (right->getKind () == Expression::eEmptySet) {
    Same:
      switch (op) {
      case SetExpression::sIntersection:
      case SetExpression::sMinus:
      case SetExpression::sUnion:
	right->destroy ();
	return left;
      case SetExpression::sSubset:
      case SetExpression::sEquals:
      True:
	left->destroy (), right->destroy ();
	return (new class Constant
		(*new class LeafValue (Net::getBoolType (), true)))->cse ();
      }
      assert (false);
    }
    else {
      assert (!!right->getType ());
      switch (op) {
      case SetExpression::sIntersection:
      case SetExpression::sMinus:
	right->destroy ();
	return left;
      case SetExpression::sUnion:
	left->destroy ();
	return right;
      case SetExpression::sSubset:
	goto True;
      case SetExpression::sEquals:
	goto Compatible;
      }
    }
  }
  else if (right->getKind () == Expression::eEmptySet) {
    switch (op) {
    case SetExpression::sIntersection:
      left->destroy ();
      return right;
    case SetExpression::sMinus:
    case SetExpression::sUnion:
      right->destroy ();
      return left;
    case SetExpression::sSubset:
      op = SetExpression::sEquals;
    case SetExpression::sEquals:
      { class Expression* e = left; left = right; right = e; }
      goto Compatible;
    }
  }

  if (left == right)
    goto Same;

  if (left->getType () == right->getType ()) {
  Compatible:
    return (new class SetExpression (op, *left, *right))->cse ();
  }
  else {
    pnerror ("expressions have incompatible types");
    left->destroy (), right->destroy ();
    return NULL;
  }
}

static class Expression*
newCardinalityExpression (enum CardinalityExpression::Op op,
			  class Expression* expr)
{
  if (class Expression* m = ensureSet (expr)) {
    if (m->getKind () == Expression::eEmptySet) {
      m->destroy ();
      pnwarn ("the cardinality of an empty set is always zero");
      return (new class Constant (*new class LeafValue
				  (Net::getCardType (),
				   op == CardinalityExpression::cMin
				   ? CARD_T_MAX
				   : 0)))->cse ();
    }
    else
      return (new class CardinalityExpression (op, *m))->cse ();
  }
  else
    return NULL;
}

static class Expression*
newBufferUnop (enum BufferUnop::Op op, class Expression* expr)
{
  if (!(expr = ensureBuffer (expr)))
    return NULL;

  if (expr->getKind () == Expression::eBufferIndex) {
    class BufferIndex* b = static_cast<class BufferIndex*>(expr);
    class Expression* buffer = &b->getBuffer ();
    class Expression* i = &b->getIndex ();
    b->destroy ();
    switch (op) {
    case BufferUnop::bFree:
    case BufferUnop::bUsed:
      if (i) {
	pnwarn ("ignoring meaningless buffer indexing expression");
	i->destroy (), i = NULL;
      }
      break;
    case BufferUnop::bPeek:
      break;
    }

    return fold (new class BufferUnop (op, *buffer, i));
  }

  return fold (new class BufferUnop (op, *expr, NULL));
}
